/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIAddToShoppingList_request.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIAddToShoppingList_request::OAIAddToShoppingList_request(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIAddToShoppingList_request::OAIAddToShoppingList_request() {
    this->initializeModel();
}

OAIAddToShoppingList_request::~OAIAddToShoppingList_request() {}

void OAIAddToShoppingList_request::initializeModel() {

    m_item_isSet = false;
    m_item_isValid = false;

    m_aisle_isSet = false;
    m_aisle_isValid = false;

    m_parse_isSet = false;
    m_parse_isValid = false;
}

void OAIAddToShoppingList_request::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIAddToShoppingList_request::fromJsonObject(QJsonObject json) {

    m_item_isValid = ::OpenAPI::fromJsonValue(m_item, json[QString("item")]);
    m_item_isSet = !json[QString("item")].isNull() && m_item_isValid;

    m_aisle_isValid = ::OpenAPI::fromJsonValue(m_aisle, json[QString("aisle")]);
    m_aisle_isSet = !json[QString("aisle")].isNull() && m_aisle_isValid;

    m_parse_isValid = ::OpenAPI::fromJsonValue(m_parse, json[QString("parse")]);
    m_parse_isSet = !json[QString("parse")].isNull() && m_parse_isValid;
}

QString OAIAddToShoppingList_request::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIAddToShoppingList_request::asJsonObject() const {
    QJsonObject obj;
    if (m_item_isSet) {
        obj.insert(QString("item"), ::OpenAPI::toJsonValue(m_item));
    }
    if (m_aisle_isSet) {
        obj.insert(QString("aisle"), ::OpenAPI::toJsonValue(m_aisle));
    }
    if (m_parse_isSet) {
        obj.insert(QString("parse"), ::OpenAPI::toJsonValue(m_parse));
    }
    return obj;
}

QString OAIAddToShoppingList_request::getItem() const {
    return m_item;
}
void OAIAddToShoppingList_request::setItem(const QString &item) {
    m_item = item;
    m_item_isSet = true;
}

bool OAIAddToShoppingList_request::is_item_Set() const{
    return m_item_isSet;
}

bool OAIAddToShoppingList_request::is_item_Valid() const{
    return m_item_isValid;
}

QString OAIAddToShoppingList_request::getAisle() const {
    return m_aisle;
}
void OAIAddToShoppingList_request::setAisle(const QString &aisle) {
    m_aisle = aisle;
    m_aisle_isSet = true;
}

bool OAIAddToShoppingList_request::is_aisle_Set() const{
    return m_aisle_isSet;
}

bool OAIAddToShoppingList_request::is_aisle_Valid() const{
    return m_aisle_isValid;
}

bool OAIAddToShoppingList_request::isParse() const {
    return m_parse;
}
void OAIAddToShoppingList_request::setParse(const bool &parse) {
    m_parse = parse;
    m_parse_isSet = true;
}

bool OAIAddToShoppingList_request::is_parse_Set() const{
    return m_parse_isSet;
}

bool OAIAddToShoppingList_request::is_parse_Valid() const{
    return m_parse_isValid;
}

bool OAIAddToShoppingList_request::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_item_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_aisle_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_parse_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIAddToShoppingList_request::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_item_isValid && m_aisle_isValid && m_parse_isValid && true;
}

} // namespace OpenAPI
