/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIAnalyzeRecipeInstructions_200_response_ingredients_inner.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::OAIAnalyzeRecipeInstructions_200_response_ingredients_inner(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::OAIAnalyzeRecipeInstructions_200_response_ingredients_inner() {
    this->initializeModel();
}

OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::~OAIAnalyzeRecipeInstructions_200_response_ingredients_inner() {}

void OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::initializeModel() {

    m_id_isSet = false;
    m_id_isValid = false;

    m_name_isSet = false;
    m_name_isValid = false;
}

void OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::fromJsonObject(QJsonObject json) {

    m_id_isValid = ::OpenAPI::fromJsonValue(m_id, json[QString("id")]);
    m_id_isSet = !json[QString("id")].isNull() && m_id_isValid;

    m_name_isValid = ::OpenAPI::fromJsonValue(m_name, json[QString("name")]);
    m_name_isSet = !json[QString("name")].isNull() && m_name_isValid;
}

QString OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::asJsonObject() const {
    QJsonObject obj;
    if (m_id_isSet) {
        obj.insert(QString("id"), ::OpenAPI::toJsonValue(m_id));
    }
    if (m_name_isSet) {
        obj.insert(QString("name"), ::OpenAPI::toJsonValue(m_name));
    }
    return obj;
}

double OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::getId() const {
    return m_id;
}
void OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::setId(const double &id) {
    m_id = id;
    m_id_isSet = true;
}

bool OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::is_id_Set() const{
    return m_id_isSet;
}

bool OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::is_id_Valid() const{
    return m_id_isValid;
}

QString OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::getName() const {
    return m_name;
}
void OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::setName(const QString &name) {
    m_name = name;
    m_name_isSet = true;
}

bool OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::is_name_Set() const{
    return m_name_isSet;
}

bool OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::is_name_Valid() const{
    return m_name_isValid;
}

bool OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_id_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_name_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIAnalyzeRecipeInstructions_200_response_ingredients_inner::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_id_isValid && m_name_isValid && true;
}

} // namespace OpenAPI
