/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner() {
    this->initializeModel();
}

OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::~OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner() {}

void OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::initializeModel() {

    m_number_isSet = false;
    m_number_isValid = false;

    m_step_isSet = false;
    m_step_isValid = false;

    m_ingredients_isSet = false;
    m_ingredients_isValid = false;

    m_equipment_isSet = false;
    m_equipment_isValid = false;
}

void OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::fromJsonObject(QJsonObject json) {

    m_number_isValid = ::OpenAPI::fromJsonValue(m_number, json[QString("number")]);
    m_number_isSet = !json[QString("number")].isNull() && m_number_isValid;

    m_step_isValid = ::OpenAPI::fromJsonValue(m_step, json[QString("step")]);
    m_step_isSet = !json[QString("step")].isNull() && m_step_isValid;

    m_ingredients_isValid = ::OpenAPI::fromJsonValue(m_ingredients, json[QString("ingredients")]);
    m_ingredients_isSet = !json[QString("ingredients")].isNull() && m_ingredients_isValid;

    m_equipment_isValid = ::OpenAPI::fromJsonValue(m_equipment, json[QString("equipment")]);
    m_equipment_isSet = !json[QString("equipment")].isNull() && m_equipment_isValid;
}

QString OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::asJsonObject() const {
    QJsonObject obj;
    if (m_number_isSet) {
        obj.insert(QString("number"), ::OpenAPI::toJsonValue(m_number));
    }
    if (m_step_isSet) {
        obj.insert(QString("step"), ::OpenAPI::toJsonValue(m_step));
    }
    if (m_ingredients.size() > 0) {
        obj.insert(QString("ingredients"), ::OpenAPI::toJsonValue(m_ingredients));
    }
    if (m_equipment.size() > 0) {
        obj.insert(QString("equipment"), ::OpenAPI::toJsonValue(m_equipment));
    }
    return obj;
}

double OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::getNumber() const {
    return m_number;
}
void OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::setNumber(const double &number) {
    m_number = number;
    m_number_isSet = true;
}

bool OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::is_number_Set() const{
    return m_number_isSet;
}

bool OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::is_number_Valid() const{
    return m_number_isValid;
}

QString OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::getStep() const {
    return m_step;
}
void OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::setStep(const QString &step) {
    m_step = step;
    m_step_isSet = true;
}

bool OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::is_step_Set() const{
    return m_step_isSet;
}

bool OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::is_step_Valid() const{
    return m_step_isValid;
}

QSet<OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner_ingredients_inner> OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::getIngredients() const {
    return m_ingredients;
}
void OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::setIngredients(const QSet<OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner_ingredients_inner> &ingredients) {
    m_ingredients = ingredients;
    m_ingredients_isSet = true;
}

bool OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::is_ingredients_Set() const{
    return m_ingredients_isSet;
}

bool OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::is_ingredients_Valid() const{
    return m_ingredients_isValid;
}

QSet<OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner_ingredients_inner> OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::getEquipment() const {
    return m_equipment;
}
void OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::setEquipment(const QSet<OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner_ingredients_inner> &equipment) {
    m_equipment = equipment;
    m_equipment_isSet = true;
}

bool OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::is_equipment_Set() const{
    return m_equipment_isSet;
}

bool OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::is_equipment_Valid() const{
    return m_equipment_isValid;
}

bool OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_number_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_step_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_ingredients.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (m_equipment.size() > 0) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner_steps_inner::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_number_isValid && m_step_isValid && true;
}

} // namespace OpenAPI
