/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIAnalyzeRecipe_request.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIAnalyzeRecipe_request::OAIAnalyzeRecipe_request(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIAnalyzeRecipe_request::OAIAnalyzeRecipe_request() {
    this->initializeModel();
}

OAIAnalyzeRecipe_request::~OAIAnalyzeRecipe_request() {}

void OAIAnalyzeRecipe_request::initializeModel() {

    m_language_isSet = false;
    m_language_isValid = false;

    m_include_nutrition_isSet = false;
    m_include_nutrition_isValid = false;

    m_include_taste_isSet = false;
    m_include_taste_isValid = false;
}

void OAIAnalyzeRecipe_request::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIAnalyzeRecipe_request::fromJsonObject(QJsonObject json) {

    m_language_isValid = ::OpenAPI::fromJsonValue(m_language, json[QString("language")]);
    m_language_isSet = !json[QString("language")].isNull() && m_language_isValid;

    m_include_nutrition_isValid = ::OpenAPI::fromJsonValue(m_include_nutrition, json[QString("includeNutrition")]);
    m_include_nutrition_isSet = !json[QString("includeNutrition")].isNull() && m_include_nutrition_isValid;

    m_include_taste_isValid = ::OpenAPI::fromJsonValue(m_include_taste, json[QString("includeTaste")]);
    m_include_taste_isSet = !json[QString("includeTaste")].isNull() && m_include_taste_isValid;
}

QString OAIAnalyzeRecipe_request::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIAnalyzeRecipe_request::asJsonObject() const {
    QJsonObject obj;
    if (m_language_isSet) {
        obj.insert(QString("language"), ::OpenAPI::toJsonValue(m_language));
    }
    if (m_include_nutrition_isSet) {
        obj.insert(QString("includeNutrition"), ::OpenAPI::toJsonValue(m_include_nutrition));
    }
    if (m_include_taste_isSet) {
        obj.insert(QString("includeTaste"), ::OpenAPI::toJsonValue(m_include_taste));
    }
    return obj;
}

QString OAIAnalyzeRecipe_request::getLanguage() const {
    return m_language;
}
void OAIAnalyzeRecipe_request::setLanguage(const QString &language) {
    m_language = language;
    m_language_isSet = true;
}

bool OAIAnalyzeRecipe_request::is_language_Set() const{
    return m_language_isSet;
}

bool OAIAnalyzeRecipe_request::is_language_Valid() const{
    return m_language_isValid;
}

bool OAIAnalyzeRecipe_request::isIncludeNutrition() const {
    return m_include_nutrition;
}
void OAIAnalyzeRecipe_request::setIncludeNutrition(const bool &include_nutrition) {
    m_include_nutrition = include_nutrition;
    m_include_nutrition_isSet = true;
}

bool OAIAnalyzeRecipe_request::is_include_nutrition_Set() const{
    return m_include_nutrition_isSet;
}

bool OAIAnalyzeRecipe_request::is_include_nutrition_Valid() const{
    return m_include_nutrition_isValid;
}

bool OAIAnalyzeRecipe_request::isIncludeTaste() const {
    return m_include_taste;
}
void OAIAnalyzeRecipe_request::setIncludeTaste(const bool &include_taste) {
    m_include_taste = include_taste;
    m_include_taste_isSet = true;
}

bool OAIAnalyzeRecipe_request::is_include_taste_Set() const{
    return m_include_taste_isSet;
}

bool OAIAnalyzeRecipe_request::is_include_taste_Valid() const{
    return m_include_taste_isValid;
}

bool OAIAnalyzeRecipe_request::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_language_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_include_nutrition_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_include_taste_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIAnalyzeRecipe_request::isValid() const {
    // only required properties are required for the object to be considered valid
    return true;
}

} // namespace OpenAPI
