/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/*
 * OAIAnalyzeRecipe_request.h
 *
 * 
 */

#ifndef OAIAnalyzeRecipe_request_H
#define OAIAnalyzeRecipe_request_H

#include <QJsonObject>

#include <QString>

#include "OAIEnum.h"
#include "OAIObject.h"

namespace OpenAPI {

class OAIAnalyzeRecipe_request : public OAIObject {
public:
    OAIAnalyzeRecipe_request();
    OAIAnalyzeRecipe_request(QString json);
    ~OAIAnalyzeRecipe_request() override;

    QString asJson() const override;
    QJsonObject asJsonObject() const override;
    void fromJsonObject(QJsonObject json) override;
    void fromJson(QString jsonString) override;

    QString getLanguage() const;
    void setLanguage(const QString &language);
    bool is_language_Set() const;
    bool is_language_Valid() const;

    bool isIncludeNutrition() const;
    void setIncludeNutrition(const bool &include_nutrition);
    bool is_include_nutrition_Set() const;
    bool is_include_nutrition_Valid() const;

    bool isIncludeTaste() const;
    void setIncludeTaste(const bool &include_taste);
    bool is_include_taste_Set() const;
    bool is_include_taste_Valid() const;

    virtual bool isSet() const override;
    virtual bool isValid() const override;

private:
    void initializeModel();

    QString m_language;
    bool m_language_isSet;
    bool m_language_isValid;

    bool m_include_nutrition;
    bool m_include_nutrition_isSet;
    bool m_include_nutrition_isValid;

    bool m_include_taste;
    bool m_include_taste_isSet;
    bool m_include_taste_isValid;
};

} // namespace OpenAPI

Q_DECLARE_METATYPE(OpenAPI::OAIAnalyzeRecipe_request)

#endif // OAIAnalyzeRecipe_request_H
