/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIClearMealPlanDay_request.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIClearMealPlanDay_request::OAIClearMealPlanDay_request(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIClearMealPlanDay_request::OAIClearMealPlanDay_request() {
    this->initializeModel();
}

OAIClearMealPlanDay_request::~OAIClearMealPlanDay_request() {}

void OAIClearMealPlanDay_request::initializeModel() {

    m_username_isSet = false;
    m_username_isValid = false;

    m_date_isSet = false;
    m_date_isValid = false;

    m_hash_isSet = false;
    m_hash_isValid = false;
}

void OAIClearMealPlanDay_request::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIClearMealPlanDay_request::fromJsonObject(QJsonObject json) {

    m_username_isValid = ::OpenAPI::fromJsonValue(m_username, json[QString("username")]);
    m_username_isSet = !json[QString("username")].isNull() && m_username_isValid;

    m_date_isValid = ::OpenAPI::fromJsonValue(m_date, json[QString("date")]);
    m_date_isSet = !json[QString("date")].isNull() && m_date_isValid;

    m_hash_isValid = ::OpenAPI::fromJsonValue(m_hash, json[QString("hash")]);
    m_hash_isSet = !json[QString("hash")].isNull() && m_hash_isValid;
}

QString OAIClearMealPlanDay_request::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIClearMealPlanDay_request::asJsonObject() const {
    QJsonObject obj;
    if (m_username_isSet) {
        obj.insert(QString("username"), ::OpenAPI::toJsonValue(m_username));
    }
    if (m_date_isSet) {
        obj.insert(QString("date"), ::OpenAPI::toJsonValue(m_date));
    }
    if (m_hash_isSet) {
        obj.insert(QString("hash"), ::OpenAPI::toJsonValue(m_hash));
    }
    return obj;
}

QString OAIClearMealPlanDay_request::getUsername() const {
    return m_username;
}
void OAIClearMealPlanDay_request::setUsername(const QString &username) {
    m_username = username;
    m_username_isSet = true;
}

bool OAIClearMealPlanDay_request::is_username_Set() const{
    return m_username_isSet;
}

bool OAIClearMealPlanDay_request::is_username_Valid() const{
    return m_username_isValid;
}

QString OAIClearMealPlanDay_request::getDate() const {
    return m_date;
}
void OAIClearMealPlanDay_request::setDate(const QString &date) {
    m_date = date;
    m_date_isSet = true;
}

bool OAIClearMealPlanDay_request::is_date_Set() const{
    return m_date_isSet;
}

bool OAIClearMealPlanDay_request::is_date_Valid() const{
    return m_date_isValid;
}

QString OAIClearMealPlanDay_request::getHash() const {
    return m_hash;
}
void OAIClearMealPlanDay_request::setHash(const QString &hash) {
    m_hash = hash;
    m_hash_isSet = true;
}

bool OAIClearMealPlanDay_request::is_hash_Set() const{
    return m_hash_isSet;
}

bool OAIClearMealPlanDay_request::is_hash_Valid() const{
    return m_hash_isValid;
}

bool OAIClearMealPlanDay_request::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_username_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_date_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_hash_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIClearMealPlanDay_request::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_username_isValid && m_date_isValid && m_hash_isValid && true;
}

} // namespace OpenAPI
