/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/*
 * OAIComputeGlycemicLoad_200_response.h
 *
 * 
 */

#ifndef OAIComputeGlycemicLoad_200_response_H
#define OAIComputeGlycemicLoad_200_response_H

#include <QJsonObject>

#include "OAIComputeGlycemicLoad_200_response_ingredients_inner.h"
#include <QSet>

#include "OAIEnum.h"
#include "OAIObject.h"

namespace OpenAPI {
class OAIComputeGlycemicLoad_200_response_ingredients_inner;

class OAIComputeGlycemicLoad_200_response : public OAIObject {
public:
    OAIComputeGlycemicLoad_200_response();
    OAIComputeGlycemicLoad_200_response(QString json);
    ~OAIComputeGlycemicLoad_200_response() override;

    QString asJson() const override;
    QJsonObject asJsonObject() const override;
    void fromJsonObject(QJsonObject json) override;
    void fromJson(QString jsonString) override;

    double getTotalGlycemicLoad() const;
    void setTotalGlycemicLoad(const double &total_glycemic_load);
    bool is_total_glycemic_load_Set() const;
    bool is_total_glycemic_load_Valid() const;

    QSet<OAIComputeGlycemicLoad_200_response_ingredients_inner> getIngredients() const;
    void setIngredients(const QSet<OAIComputeGlycemicLoad_200_response_ingredients_inner> &ingredients);
    bool is_ingredients_Set() const;
    bool is_ingredients_Valid() const;

    virtual bool isSet() const override;
    virtual bool isValid() const override;

private:
    void initializeModel();

    double m_total_glycemic_load;
    bool m_total_glycemic_load_isSet;
    bool m_total_glycemic_load_isValid;

    QSet<OAIComputeGlycemicLoad_200_response_ingredients_inner> m_ingredients;
    bool m_ingredients_isSet;
    bool m_ingredients_isValid;
};

} // namespace OpenAPI

Q_DECLARE_METATYPE(OpenAPI::OAIComputeGlycemicLoad_200_response)

#endif // OAIComputeGlycemicLoad_200_response_H
