/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/*
 * OAIGenerateMealPlan_200_response_nutrients.h
 *
 * 
 */

#ifndef OAIGenerateMealPlan_200_response_nutrients_H
#define OAIGenerateMealPlan_200_response_nutrients_H

#include <QJsonObject>


#include "OAIEnum.h"
#include "OAIObject.h"

namespace OpenAPI {

class OAIGenerateMealPlan_200_response_nutrients : public OAIObject {
public:
    OAIGenerateMealPlan_200_response_nutrients();
    OAIGenerateMealPlan_200_response_nutrients(QString json);
    ~OAIGenerateMealPlan_200_response_nutrients() override;

    QString asJson() const override;
    QJsonObject asJsonObject() const override;
    void fromJsonObject(QJsonObject json) override;
    void fromJson(QString jsonString) override;

    double getCalories() const;
    void setCalories(const double &calories);
    bool is_calories_Set() const;
    bool is_calories_Valid() const;

    double getCarbohydrates() const;
    void setCarbohydrates(const double &carbohydrates);
    bool is_carbohydrates_Set() const;
    bool is_carbohydrates_Valid() const;

    double getFat() const;
    void setFat(const double &fat);
    bool is_fat_Set() const;
    bool is_fat_Valid() const;

    double getProtein() const;
    void setProtein(const double &protein);
    bool is_protein_Set() const;
    bool is_protein_Valid() const;

    virtual bool isSet() const override;
    virtual bool isValid() const override;

private:
    void initializeModel();

    double m_calories;
    bool m_calories_isSet;
    bool m_calories_isValid;

    double m_carbohydrates;
    bool m_carbohydrates_isSet;
    bool m_carbohydrates_isValid;

    double m_fat;
    bool m_fat_isSet;
    bool m_fat_isValid;

    double m_protein;
    bool m_protein_isSet;
    bool m_protein_isValid;
};

} // namespace OpenAPI

Q_DECLARE_METATYPE(OpenAPI::OAIGenerateMealPlan_200_response_nutrients)

#endif // OAIGenerateMealPlan_200_response_nutrients_H
