/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIGetConversationSuggests_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIGetConversationSuggests_200_response::OAIGetConversationSuggests_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIGetConversationSuggests_200_response::OAIGetConversationSuggests_200_response() {
    this->initializeModel();
}

OAIGetConversationSuggests_200_response::~OAIGetConversationSuggests_200_response() {}

void OAIGetConversationSuggests_200_response::initializeModel() {

    m_suggests_isSet = false;
    m_suggests_isValid = false;

    m_words_isSet = false;
    m_words_isValid = false;
}

void OAIGetConversationSuggests_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIGetConversationSuggests_200_response::fromJsonObject(QJsonObject json) {

    m_suggests_isValid = ::OpenAPI::fromJsonValue(m_suggests, json[QString("suggests")]);
    m_suggests_isSet = !json[QString("suggests")].isNull() && m_suggests_isValid;

    m_words_isValid = ::OpenAPI::fromJsonValue(m_words, json[QString("words")]);
    m_words_isSet = !json[QString("words")].isNull() && m_words_isValid;
}

QString OAIGetConversationSuggests_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIGetConversationSuggests_200_response::asJsonObject() const {
    QJsonObject obj;
    if (m_suggests.isSet()) {
        obj.insert(QString("suggests"), ::OpenAPI::toJsonValue(m_suggests));
    }
    if (m_words.size() > 0) {
        obj.insert(QString("words"), ::OpenAPI::toJsonValue(m_words));
    }
    return obj;
}

OAIGetConversationSuggests_200_response_suggests OAIGetConversationSuggests_200_response::getSuggests() const {
    return m_suggests;
}
void OAIGetConversationSuggests_200_response::setSuggests(const OAIGetConversationSuggests_200_response_suggests &suggests) {
    m_suggests = suggests;
    m_suggests_isSet = true;
}

bool OAIGetConversationSuggests_200_response::is_suggests_Set() const{
    return m_suggests_isSet;
}

bool OAIGetConversationSuggests_200_response::is_suggests_Valid() const{
    return m_suggests_isValid;
}

QList<QJsonValue> OAIGetConversationSuggests_200_response::getWords() const {
    return m_words;
}
void OAIGetConversationSuggests_200_response::setWords(const QList<QJsonValue> &words) {
    m_words = words;
    m_words_isSet = true;
}

bool OAIGetConversationSuggests_200_response::is_words_Set() const{
    return m_words_isSet;
}

bool OAIGetConversationSuggests_200_response::is_words_Valid() const{
    return m_words_isValid;
}

bool OAIGetConversationSuggests_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_suggests.isSet()) {
            isObjectUpdated = true;
            break;
        }

        if (m_words.size() > 0) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIGetConversationSuggests_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_suggests_isValid && m_words_isValid && true;
}

} // namespace OpenAPI
