/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/*
 * OAIGetConversationSuggests_200_response.h
 *
 * 
 */

#ifndef OAIGetConversationSuggests_200_response_H
#define OAIGetConversationSuggests_200_response_H

#include <QJsonObject>

#include "OAIGetConversationSuggests_200_response_suggests.h"
#include <QJsonValue>
#include <QList>

#include "OAIEnum.h"
#include "OAIObject.h"

namespace OpenAPI {
class OAIGetConversationSuggests_200_response_suggests;

class OAIGetConversationSuggests_200_response : public OAIObject {
public:
    OAIGetConversationSuggests_200_response();
    OAIGetConversationSuggests_200_response(QString json);
    ~OAIGetConversationSuggests_200_response() override;

    QString asJson() const override;
    QJsonObject asJsonObject() const override;
    void fromJsonObject(QJsonObject json) override;
    void fromJson(QString jsonString) override;

    OAIGetConversationSuggests_200_response_suggests getSuggests() const;
    void setSuggests(const OAIGetConversationSuggests_200_response_suggests &suggests);
    bool is_suggests_Set() const;
    bool is_suggests_Valid() const;

    QList<QJsonValue> getWords() const;
    void setWords(const QList<QJsonValue> &words);
    bool is_words_Set() const;
    bool is_words_Valid() const;

    virtual bool isSet() const override;
    virtual bool isValid() const override;

private:
    void initializeModel();

    OAIGetConversationSuggests_200_response_suggests m_suggests;
    bool m_suggests_isSet;
    bool m_suggests_isValid;

    QList<QJsonValue> m_words;
    bool m_words_isSet;
    bool m_words_isValid;
};

} // namespace OpenAPI

Q_DECLARE_METATYPE(OpenAPI::OAIGetConversationSuggests_200_response)

#endif // OAIGetConversationSuggests_200_response_H
