/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIGetProductInformation_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIGetProductInformation_200_response::OAIGetProductInformation_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIGetProductInformation_200_response::OAIGetProductInformation_200_response() {
    this->initializeModel();
}

OAIGetProductInformation_200_response::~OAIGetProductInformation_200_response() {}

void OAIGetProductInformation_200_response::initializeModel() {

    m_id_isSet = false;
    m_id_isValid = false;

    m_title_isSet = false;
    m_title_isValid = false;

    m_breadcrumbs_isSet = false;
    m_breadcrumbs_isValid = false;

    m_image_type_isSet = false;
    m_image_type_isValid = false;

    m_badges_isSet = false;
    m_badges_isValid = false;

    m_important_badges_isSet = false;
    m_important_badges_isValid = false;

    m_ingredient_count_isSet = false;
    m_ingredient_count_isValid = false;

    m_generated_text_isSet = false;
    m_generated_text_isValid = false;

    m_ingredient_list_isSet = false;
    m_ingredient_list_isValid = false;

    m_ingredients_isSet = false;
    m_ingredients_isValid = false;

    m_likes_isSet = false;
    m_likes_isValid = false;

    m_aisle_isSet = false;
    m_aisle_isValid = false;

    m_nutrition_isSet = false;
    m_nutrition_isValid = false;

    m_price_isSet = false;
    m_price_isValid = false;

    m_servings_isSet = false;
    m_servings_isValid = false;

    m_spoonacular_score_isSet = false;
    m_spoonacular_score_isValid = false;
}

void OAIGetProductInformation_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIGetProductInformation_200_response::fromJsonObject(QJsonObject json) {

    m_id_isValid = ::OpenAPI::fromJsonValue(m_id, json[QString("id")]);
    m_id_isSet = !json[QString("id")].isNull() && m_id_isValid;

    m_title_isValid = ::OpenAPI::fromJsonValue(m_title, json[QString("title")]);
    m_title_isSet = !json[QString("title")].isNull() && m_title_isValid;

    m_breadcrumbs_isValid = ::OpenAPI::fromJsonValue(m_breadcrumbs, json[QString("breadcrumbs")]);
    m_breadcrumbs_isSet = !json[QString("breadcrumbs")].isNull() && m_breadcrumbs_isValid;

    m_image_type_isValid = ::OpenAPI::fromJsonValue(m_image_type, json[QString("imageType")]);
    m_image_type_isSet = !json[QString("imageType")].isNull() && m_image_type_isValid;

    m_badges_isValid = ::OpenAPI::fromJsonValue(m_badges, json[QString("badges")]);
    m_badges_isSet = !json[QString("badges")].isNull() && m_badges_isValid;

    m_important_badges_isValid = ::OpenAPI::fromJsonValue(m_important_badges, json[QString("importantBadges")]);
    m_important_badges_isSet = !json[QString("importantBadges")].isNull() && m_important_badges_isValid;

    m_ingredient_count_isValid = ::OpenAPI::fromJsonValue(m_ingredient_count, json[QString("ingredientCount")]);
    m_ingredient_count_isSet = !json[QString("ingredientCount")].isNull() && m_ingredient_count_isValid;

    m_generated_text_isValid = ::OpenAPI::fromJsonValue(m_generated_text, json[QString("generatedText")]);
    m_generated_text_isSet = !json[QString("generatedText")].isNull() && m_generated_text_isValid;

    m_ingredient_list_isValid = ::OpenAPI::fromJsonValue(m_ingredient_list, json[QString("ingredientList")]);
    m_ingredient_list_isSet = !json[QString("ingredientList")].isNull() && m_ingredient_list_isValid;

    m_ingredients_isValid = ::OpenAPI::fromJsonValue(m_ingredients, json[QString("ingredients")]);
    m_ingredients_isSet = !json[QString("ingredients")].isNull() && m_ingredients_isValid;

    m_likes_isValid = ::OpenAPI::fromJsonValue(m_likes, json[QString("likes")]);
    m_likes_isSet = !json[QString("likes")].isNull() && m_likes_isValid;

    m_aisle_isValid = ::OpenAPI::fromJsonValue(m_aisle, json[QString("aisle")]);
    m_aisle_isSet = !json[QString("aisle")].isNull() && m_aisle_isValid;

    m_nutrition_isValid = ::OpenAPI::fromJsonValue(m_nutrition, json[QString("nutrition")]);
    m_nutrition_isSet = !json[QString("nutrition")].isNull() && m_nutrition_isValid;

    m_price_isValid = ::OpenAPI::fromJsonValue(m_price, json[QString("price")]);
    m_price_isSet = !json[QString("price")].isNull() && m_price_isValid;

    m_servings_isValid = ::OpenAPI::fromJsonValue(m_servings, json[QString("servings")]);
    m_servings_isSet = !json[QString("servings")].isNull() && m_servings_isValid;

    m_spoonacular_score_isValid = ::OpenAPI::fromJsonValue(m_spoonacular_score, json[QString("spoonacularScore")]);
    m_spoonacular_score_isSet = !json[QString("spoonacularScore")].isNull() && m_spoonacular_score_isValid;
}

QString OAIGetProductInformation_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIGetProductInformation_200_response::asJsonObject() const {
    QJsonObject obj;
    if (m_id_isSet) {
        obj.insert(QString("id"), ::OpenAPI::toJsonValue(m_id));
    }
    if (m_title_isSet) {
        obj.insert(QString("title"), ::OpenAPI::toJsonValue(m_title));
    }
    if (m_breadcrumbs.size() > 0) {
        obj.insert(QString("breadcrumbs"), ::OpenAPI::toJsonValue(m_breadcrumbs));
    }
    if (m_image_type_isSet) {
        obj.insert(QString("imageType"), ::OpenAPI::toJsonValue(m_image_type));
    }
    if (m_badges.size() > 0) {
        obj.insert(QString("badges"), ::OpenAPI::toJsonValue(m_badges));
    }
    if (m_important_badges.size() > 0) {
        obj.insert(QString("importantBadges"), ::OpenAPI::toJsonValue(m_important_badges));
    }
    if (m_ingredient_count_isSet) {
        obj.insert(QString("ingredientCount"), ::OpenAPI::toJsonValue(m_ingredient_count));
    }
    if (m_generated_text_isSet) {
        obj.insert(QString("generatedText"), ::OpenAPI::toJsonValue(m_generated_text));
    }
    if (m_ingredient_list_isSet) {
        obj.insert(QString("ingredientList"), ::OpenAPI::toJsonValue(m_ingredient_list));
    }
    if (m_ingredients.size() > 0) {
        obj.insert(QString("ingredients"), ::OpenAPI::toJsonValue(m_ingredients));
    }
    if (m_likes_isSet) {
        obj.insert(QString("likes"), ::OpenAPI::toJsonValue(m_likes));
    }
    if (m_aisle_isSet) {
        obj.insert(QString("aisle"), ::OpenAPI::toJsonValue(m_aisle));
    }
    if (m_nutrition.isSet()) {
        obj.insert(QString("nutrition"), ::OpenAPI::toJsonValue(m_nutrition));
    }
    if (m_price_isSet) {
        obj.insert(QString("price"), ::OpenAPI::toJsonValue(m_price));
    }
    if (m_servings.isSet()) {
        obj.insert(QString("servings"), ::OpenAPI::toJsonValue(m_servings));
    }
    if (m_spoonacular_score_isSet) {
        obj.insert(QString("spoonacularScore"), ::OpenAPI::toJsonValue(m_spoonacular_score));
    }
    return obj;
}

qint32 OAIGetProductInformation_200_response::getId() const {
    return m_id;
}
void OAIGetProductInformation_200_response::setId(const qint32 &id) {
    m_id = id;
    m_id_isSet = true;
}

bool OAIGetProductInformation_200_response::is_id_Set() const{
    return m_id_isSet;
}

bool OAIGetProductInformation_200_response::is_id_Valid() const{
    return m_id_isValid;
}

QString OAIGetProductInformation_200_response::getTitle() const {
    return m_title;
}
void OAIGetProductInformation_200_response::setTitle(const QString &title) {
    m_title = title;
    m_title_isSet = true;
}

bool OAIGetProductInformation_200_response::is_title_Set() const{
    return m_title_isSet;
}

bool OAIGetProductInformation_200_response::is_title_Valid() const{
    return m_title_isValid;
}

QList<QString> OAIGetProductInformation_200_response::getBreadcrumbs() const {
    return m_breadcrumbs;
}
void OAIGetProductInformation_200_response::setBreadcrumbs(const QList<QString> &breadcrumbs) {
    m_breadcrumbs = breadcrumbs;
    m_breadcrumbs_isSet = true;
}

bool OAIGetProductInformation_200_response::is_breadcrumbs_Set() const{
    return m_breadcrumbs_isSet;
}

bool OAIGetProductInformation_200_response::is_breadcrumbs_Valid() const{
    return m_breadcrumbs_isValid;
}

QString OAIGetProductInformation_200_response::getImageType() const {
    return m_image_type;
}
void OAIGetProductInformation_200_response::setImageType(const QString &image_type) {
    m_image_type = image_type;
    m_image_type_isSet = true;
}

bool OAIGetProductInformation_200_response::is_image_type_Set() const{
    return m_image_type_isSet;
}

bool OAIGetProductInformation_200_response::is_image_type_Valid() const{
    return m_image_type_isValid;
}

QList<QString> OAIGetProductInformation_200_response::getBadges() const {
    return m_badges;
}
void OAIGetProductInformation_200_response::setBadges(const QList<QString> &badges) {
    m_badges = badges;
    m_badges_isSet = true;
}

bool OAIGetProductInformation_200_response::is_badges_Set() const{
    return m_badges_isSet;
}

bool OAIGetProductInformation_200_response::is_badges_Valid() const{
    return m_badges_isValid;
}

QList<QString> OAIGetProductInformation_200_response::getImportantBadges() const {
    return m_important_badges;
}
void OAIGetProductInformation_200_response::setImportantBadges(const QList<QString> &important_badges) {
    m_important_badges = important_badges;
    m_important_badges_isSet = true;
}

bool OAIGetProductInformation_200_response::is_important_badges_Set() const{
    return m_important_badges_isSet;
}

bool OAIGetProductInformation_200_response::is_important_badges_Valid() const{
    return m_important_badges_isValid;
}

qint32 OAIGetProductInformation_200_response::getIngredientCount() const {
    return m_ingredient_count;
}
void OAIGetProductInformation_200_response::setIngredientCount(const qint32 &ingredient_count) {
    m_ingredient_count = ingredient_count;
    m_ingredient_count_isSet = true;
}

bool OAIGetProductInformation_200_response::is_ingredient_count_Set() const{
    return m_ingredient_count_isSet;
}

bool OAIGetProductInformation_200_response::is_ingredient_count_Valid() const{
    return m_ingredient_count_isValid;
}

QJsonValue OAIGetProductInformation_200_response::getGeneratedText() const {
    return m_generated_text;
}
void OAIGetProductInformation_200_response::setGeneratedText(const QJsonValue &generated_text) {
    m_generated_text = generated_text;
    m_generated_text_isSet = true;
}

bool OAIGetProductInformation_200_response::is_generated_text_Set() const{
    return m_generated_text_isSet;
}

bool OAIGetProductInformation_200_response::is_generated_text_Valid() const{
    return m_generated_text_isValid;
}

QString OAIGetProductInformation_200_response::getIngredientList() const {
    return m_ingredient_list;
}
void OAIGetProductInformation_200_response::setIngredientList(const QString &ingredient_list) {
    m_ingredient_list = ingredient_list;
    m_ingredient_list_isSet = true;
}

bool OAIGetProductInformation_200_response::is_ingredient_list_Set() const{
    return m_ingredient_list_isSet;
}

bool OAIGetProductInformation_200_response::is_ingredient_list_Valid() const{
    return m_ingredient_list_isValid;
}

QList<OAIGetProductInformation_200_response_ingredients_inner> OAIGetProductInformation_200_response::getIngredients() const {
    return m_ingredients;
}
void OAIGetProductInformation_200_response::setIngredients(const QList<OAIGetProductInformation_200_response_ingredients_inner> &ingredients) {
    m_ingredients = ingredients;
    m_ingredients_isSet = true;
}

bool OAIGetProductInformation_200_response::is_ingredients_Set() const{
    return m_ingredients_isSet;
}

bool OAIGetProductInformation_200_response::is_ingredients_Valid() const{
    return m_ingredients_isValid;
}

double OAIGetProductInformation_200_response::getLikes() const {
    return m_likes;
}
void OAIGetProductInformation_200_response::setLikes(const double &likes) {
    m_likes = likes;
    m_likes_isSet = true;
}

bool OAIGetProductInformation_200_response::is_likes_Set() const{
    return m_likes_isSet;
}

bool OAIGetProductInformation_200_response::is_likes_Valid() const{
    return m_likes_isValid;
}

QString OAIGetProductInformation_200_response::getAisle() const {
    return m_aisle;
}
void OAIGetProductInformation_200_response::setAisle(const QString &aisle) {
    m_aisle = aisle;
    m_aisle_isSet = true;
}

bool OAIGetProductInformation_200_response::is_aisle_Set() const{
    return m_aisle_isSet;
}

bool OAIGetProductInformation_200_response::is_aisle_Valid() const{
    return m_aisle_isValid;
}

OAISearchGroceryProductsByUPC_200_response_nutrition OAIGetProductInformation_200_response::getNutrition() const {
    return m_nutrition;
}
void OAIGetProductInformation_200_response::setNutrition(const OAISearchGroceryProductsByUPC_200_response_nutrition &nutrition) {
    m_nutrition = nutrition;
    m_nutrition_isSet = true;
}

bool OAIGetProductInformation_200_response::is_nutrition_Set() const{
    return m_nutrition_isSet;
}

bool OAIGetProductInformation_200_response::is_nutrition_Valid() const{
    return m_nutrition_isValid;
}

double OAIGetProductInformation_200_response::getPrice() const {
    return m_price;
}
void OAIGetProductInformation_200_response::setPrice(const double &price) {
    m_price = price;
    m_price_isSet = true;
}

bool OAIGetProductInformation_200_response::is_price_Set() const{
    return m_price_isSet;
}

bool OAIGetProductInformation_200_response::is_price_Valid() const{
    return m_price_isValid;
}

OAISearchGroceryProductsByUPC_200_response_servings OAIGetProductInformation_200_response::getServings() const {
    return m_servings;
}
void OAIGetProductInformation_200_response::setServings(const OAISearchGroceryProductsByUPC_200_response_servings &servings) {
    m_servings = servings;
    m_servings_isSet = true;
}

bool OAIGetProductInformation_200_response::is_servings_Set() const{
    return m_servings_isSet;
}

bool OAIGetProductInformation_200_response::is_servings_Valid() const{
    return m_servings_isValid;
}

double OAIGetProductInformation_200_response::getSpoonacularScore() const {
    return m_spoonacular_score;
}
void OAIGetProductInformation_200_response::setSpoonacularScore(const double &spoonacular_score) {
    m_spoonacular_score = spoonacular_score;
    m_spoonacular_score_isSet = true;
}

bool OAIGetProductInformation_200_response::is_spoonacular_score_Set() const{
    return m_spoonacular_score_isSet;
}

bool OAIGetProductInformation_200_response::is_spoonacular_score_Valid() const{
    return m_spoonacular_score_isValid;
}

bool OAIGetProductInformation_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_id_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_title_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_breadcrumbs.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (m_image_type_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_badges.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (m_important_badges.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (m_ingredient_count_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_generated_text_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_ingredient_list_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_ingredients.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (m_likes_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_aisle_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_nutrition.isSet()) {
            isObjectUpdated = true;
            break;
        }

        if (m_price_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_servings.isSet()) {
            isObjectUpdated = true;
            break;
        }

        if (m_spoonacular_score_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIGetProductInformation_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_id_isValid && m_title_isValid && m_breadcrumbs_isValid && m_image_type_isValid && m_badges_isValid && m_important_badges_isValid && m_ingredient_count_isValid && m_ingredient_list_isValid && m_ingredients_isValid && m_likes_isValid && m_aisle_isValid && m_nutrition_isValid && m_price_isValid && m_servings_isValid && m_spoonacular_score_isValid && true;
}

} // namespace OpenAPI
