/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIImageAnalysisByURL_200_response_category.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIImageAnalysisByURL_200_response_category::OAIImageAnalysisByURL_200_response_category(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIImageAnalysisByURL_200_response_category::OAIImageAnalysisByURL_200_response_category() {
    this->initializeModel();
}

OAIImageAnalysisByURL_200_response_category::~OAIImageAnalysisByURL_200_response_category() {}

void OAIImageAnalysisByURL_200_response_category::initializeModel() {

    m_name_isSet = false;
    m_name_isValid = false;

    m_probability_isSet = false;
    m_probability_isValid = false;
}

void OAIImageAnalysisByURL_200_response_category::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIImageAnalysisByURL_200_response_category::fromJsonObject(QJsonObject json) {

    m_name_isValid = ::OpenAPI::fromJsonValue(m_name, json[QString("name")]);
    m_name_isSet = !json[QString("name")].isNull() && m_name_isValid;

    m_probability_isValid = ::OpenAPI::fromJsonValue(m_probability, json[QString("probability")]);
    m_probability_isSet = !json[QString("probability")].isNull() && m_probability_isValid;
}

QString OAIImageAnalysisByURL_200_response_category::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIImageAnalysisByURL_200_response_category::asJsonObject() const {
    QJsonObject obj;
    if (m_name_isSet) {
        obj.insert(QString("name"), ::OpenAPI::toJsonValue(m_name));
    }
    if (m_probability_isSet) {
        obj.insert(QString("probability"), ::OpenAPI::toJsonValue(m_probability));
    }
    return obj;
}

QString OAIImageAnalysisByURL_200_response_category::getName() const {
    return m_name;
}
void OAIImageAnalysisByURL_200_response_category::setName(const QString &name) {
    m_name = name;
    m_name_isSet = true;
}

bool OAIImageAnalysisByURL_200_response_category::is_name_Set() const{
    return m_name_isSet;
}

bool OAIImageAnalysisByURL_200_response_category::is_name_Valid() const{
    return m_name_isValid;
}

double OAIImageAnalysisByURL_200_response_category::getProbability() const {
    return m_probability;
}
void OAIImageAnalysisByURL_200_response_category::setProbability(const double &probability) {
    m_probability = probability;
    m_probability_isSet = true;
}

bool OAIImageAnalysisByURL_200_response_category::is_probability_Set() const{
    return m_probability_isSet;
}

bool OAIImageAnalysisByURL_200_response_category::is_probability_Valid() const{
    return m_probability_isValid;
}

bool OAIImageAnalysisByURL_200_response_category::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_name_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_probability_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIImageAnalysisByURL_200_response_category::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_name_isValid && m_probability_isValid && true;
}

} // namespace OpenAPI
