/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIQuickAnswer_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIQuickAnswer_200_response::OAIQuickAnswer_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIQuickAnswer_200_response::OAIQuickAnswer_200_response() {
    this->initializeModel();
}

OAIQuickAnswer_200_response::~OAIQuickAnswer_200_response() {}

void OAIQuickAnswer_200_response::initializeModel() {

    m_answer_isSet = false;
    m_answer_isValid = false;

    m_image_isSet = false;
    m_image_isValid = false;
}

void OAIQuickAnswer_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIQuickAnswer_200_response::fromJsonObject(QJsonObject json) {

    m_answer_isValid = ::OpenAPI::fromJsonValue(m_answer, json[QString("answer")]);
    m_answer_isSet = !json[QString("answer")].isNull() && m_answer_isValid;

    m_image_isValid = ::OpenAPI::fromJsonValue(m_image, json[QString("image")]);
    m_image_isSet = !json[QString("image")].isNull() && m_image_isValid;
}

QString OAIQuickAnswer_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIQuickAnswer_200_response::asJsonObject() const {
    QJsonObject obj;
    if (m_answer_isSet) {
        obj.insert(QString("answer"), ::OpenAPI::toJsonValue(m_answer));
    }
    if (m_image_isSet) {
        obj.insert(QString("image"), ::OpenAPI::toJsonValue(m_image));
    }
    return obj;
}

QString OAIQuickAnswer_200_response::getAnswer() const {
    return m_answer;
}
void OAIQuickAnswer_200_response::setAnswer(const QString &answer) {
    m_answer = answer;
    m_answer_isSet = true;
}

bool OAIQuickAnswer_200_response::is_answer_Set() const{
    return m_answer_isSet;
}

bool OAIQuickAnswer_200_response::is_answer_Valid() const{
    return m_answer_isValid;
}

QString OAIQuickAnswer_200_response::getImage() const {
    return m_image;
}
void OAIQuickAnswer_200_response::setImage(const QString &image) {
    m_image = image;
    m_image_isSet = true;
}

bool OAIQuickAnswer_200_response::is_image_Set() const{
    return m_image_isSet;
}

bool OAIQuickAnswer_200_response::is_image_Valid() const{
    return m_image_isValid;
}

bool OAIQuickAnswer_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_answer_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_image_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIQuickAnswer_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_answer_isValid && m_image_isValid && true;
}

} // namespace OpenAPI
