/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/*
 * OAISearchFoodVideos_200_response.h
 *
 * 
 */

#ifndef OAISearchFoodVideos_200_response_H
#define OAISearchFoodVideos_200_response_H

#include <QJsonObject>

#include "OAISearchFoodVideos_200_response_videos_inner.h"
#include <QSet>

#include "OAIEnum.h"
#include "OAIObject.h"

namespace OpenAPI {
class OAISearchFoodVideos_200_response_videos_inner;

class OAISearchFoodVideos_200_response : public OAIObject {
public:
    OAISearchFoodVideos_200_response();
    OAISearchFoodVideos_200_response(QString json);
    ~OAISearchFoodVideos_200_response() override;

    QString asJson() const override;
    QJsonObject asJsonObject() const override;
    void fromJsonObject(QJsonObject json) override;
    void fromJson(QString jsonString) override;

    QSet<OAISearchFoodVideos_200_response_videos_inner> getVideos() const;
    void setVideos(const QSet<OAISearchFoodVideos_200_response_videos_inner> &videos);
    bool is_videos_Set() const;
    bool is_videos_Valid() const;

    qint32 getTotalResults() const;
    void setTotalResults(const qint32 &total_results);
    bool is_total_results_Set() const;
    bool is_total_results_Valid() const;

    virtual bool isSet() const override;
    virtual bool isValid() const override;

private:
    void initializeModel();

    QSet<OAISearchFoodVideos_200_response_videos_inner> m_videos;
    bool m_videos_isSet;
    bool m_videos_isValid;

    qint32 m_total_results;
    bool m_total_results_isSet;
    bool m_total_results_isValid;
};

} // namespace OpenAPI

Q_DECLARE_METATYPE(OpenAPI::OAISearchFoodVideos_200_response)

#endif // OAISearchFoodVideos_200_response_H
