/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAISearchRecipes_200_response_results_inner.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAISearchRecipes_200_response_results_inner::OAISearchRecipes_200_response_results_inner(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAISearchRecipes_200_response_results_inner::OAISearchRecipes_200_response_results_inner() {
    this->initializeModel();
}

OAISearchRecipes_200_response_results_inner::~OAISearchRecipes_200_response_results_inner() {}

void OAISearchRecipes_200_response_results_inner::initializeModel() {

    m_id_isSet = false;
    m_id_isValid = false;

    m_title_isSet = false;
    m_title_isValid = false;

    m_calories_isSet = false;
    m_calories_isValid = false;

    m_carbs_isSet = false;
    m_carbs_isValid = false;

    m_fat_isSet = false;
    m_fat_isValid = false;

    m_image_isSet = false;
    m_image_isValid = false;

    m_image_type_isSet = false;
    m_image_type_isValid = false;

    m_protein_isSet = false;
    m_protein_isValid = false;
}

void OAISearchRecipes_200_response_results_inner::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAISearchRecipes_200_response_results_inner::fromJsonObject(QJsonObject json) {

    m_id_isValid = ::OpenAPI::fromJsonValue(m_id, json[QString("id")]);
    m_id_isSet = !json[QString("id")].isNull() && m_id_isValid;

    m_title_isValid = ::OpenAPI::fromJsonValue(m_title, json[QString("title")]);
    m_title_isSet = !json[QString("title")].isNull() && m_title_isValid;

    m_calories_isValid = ::OpenAPI::fromJsonValue(m_calories, json[QString("calories")]);
    m_calories_isSet = !json[QString("calories")].isNull() && m_calories_isValid;

    m_carbs_isValid = ::OpenAPI::fromJsonValue(m_carbs, json[QString("carbs")]);
    m_carbs_isSet = !json[QString("carbs")].isNull() && m_carbs_isValid;

    m_fat_isValid = ::OpenAPI::fromJsonValue(m_fat, json[QString("fat")]);
    m_fat_isSet = !json[QString("fat")].isNull() && m_fat_isValid;

    m_image_isValid = ::OpenAPI::fromJsonValue(m_image, json[QString("image")]);
    m_image_isSet = !json[QString("image")].isNull() && m_image_isValid;

    m_image_type_isValid = ::OpenAPI::fromJsonValue(m_image_type, json[QString("imageType")]);
    m_image_type_isSet = !json[QString("imageType")].isNull() && m_image_type_isValid;

    m_protein_isValid = ::OpenAPI::fromJsonValue(m_protein, json[QString("protein")]);
    m_protein_isSet = !json[QString("protein")].isNull() && m_protein_isValid;
}

QString OAISearchRecipes_200_response_results_inner::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAISearchRecipes_200_response_results_inner::asJsonObject() const {
    QJsonObject obj;
    if (m_id_isSet) {
        obj.insert(QString("id"), ::OpenAPI::toJsonValue(m_id));
    }
    if (m_title_isSet) {
        obj.insert(QString("title"), ::OpenAPI::toJsonValue(m_title));
    }
    if (m_calories_isSet) {
        obj.insert(QString("calories"), ::OpenAPI::toJsonValue(m_calories));
    }
    if (m_carbs_isSet) {
        obj.insert(QString("carbs"), ::OpenAPI::toJsonValue(m_carbs));
    }
    if (m_fat_isSet) {
        obj.insert(QString("fat"), ::OpenAPI::toJsonValue(m_fat));
    }
    if (m_image_isSet) {
        obj.insert(QString("image"), ::OpenAPI::toJsonValue(m_image));
    }
    if (m_image_type_isSet) {
        obj.insert(QString("imageType"), ::OpenAPI::toJsonValue(m_image_type));
    }
    if (m_protein_isSet) {
        obj.insert(QString("protein"), ::OpenAPI::toJsonValue(m_protein));
    }
    return obj;
}

qint32 OAISearchRecipes_200_response_results_inner::getId() const {
    return m_id;
}
void OAISearchRecipes_200_response_results_inner::setId(const qint32 &id) {
    m_id = id;
    m_id_isSet = true;
}

bool OAISearchRecipes_200_response_results_inner::is_id_Set() const{
    return m_id_isSet;
}

bool OAISearchRecipes_200_response_results_inner::is_id_Valid() const{
    return m_id_isValid;
}

QString OAISearchRecipes_200_response_results_inner::getTitle() const {
    return m_title;
}
void OAISearchRecipes_200_response_results_inner::setTitle(const QString &title) {
    m_title = title;
    m_title_isSet = true;
}

bool OAISearchRecipes_200_response_results_inner::is_title_Set() const{
    return m_title_isSet;
}

bool OAISearchRecipes_200_response_results_inner::is_title_Valid() const{
    return m_title_isValid;
}

double OAISearchRecipes_200_response_results_inner::getCalories() const {
    return m_calories;
}
void OAISearchRecipes_200_response_results_inner::setCalories(const double &calories) {
    m_calories = calories;
    m_calories_isSet = true;
}

bool OAISearchRecipes_200_response_results_inner::is_calories_Set() const{
    return m_calories_isSet;
}

bool OAISearchRecipes_200_response_results_inner::is_calories_Valid() const{
    return m_calories_isValid;
}

QString OAISearchRecipes_200_response_results_inner::getCarbs() const {
    return m_carbs;
}
void OAISearchRecipes_200_response_results_inner::setCarbs(const QString &carbs) {
    m_carbs = carbs;
    m_carbs_isSet = true;
}

bool OAISearchRecipes_200_response_results_inner::is_carbs_Set() const{
    return m_carbs_isSet;
}

bool OAISearchRecipes_200_response_results_inner::is_carbs_Valid() const{
    return m_carbs_isValid;
}

QString OAISearchRecipes_200_response_results_inner::getFat() const {
    return m_fat;
}
void OAISearchRecipes_200_response_results_inner::setFat(const QString &fat) {
    m_fat = fat;
    m_fat_isSet = true;
}

bool OAISearchRecipes_200_response_results_inner::is_fat_Set() const{
    return m_fat_isSet;
}

bool OAISearchRecipes_200_response_results_inner::is_fat_Valid() const{
    return m_fat_isValid;
}

QString OAISearchRecipes_200_response_results_inner::getImage() const {
    return m_image;
}
void OAISearchRecipes_200_response_results_inner::setImage(const QString &image) {
    m_image = image;
    m_image_isSet = true;
}

bool OAISearchRecipes_200_response_results_inner::is_image_Set() const{
    return m_image_isSet;
}

bool OAISearchRecipes_200_response_results_inner::is_image_Valid() const{
    return m_image_isValid;
}

QString OAISearchRecipes_200_response_results_inner::getImageType() const {
    return m_image_type;
}
void OAISearchRecipes_200_response_results_inner::setImageType(const QString &image_type) {
    m_image_type = image_type;
    m_image_type_isSet = true;
}

bool OAISearchRecipes_200_response_results_inner::is_image_type_Set() const{
    return m_image_type_isSet;
}

bool OAISearchRecipes_200_response_results_inner::is_image_type_Valid() const{
    return m_image_type_isValid;
}

QString OAISearchRecipes_200_response_results_inner::getProtein() const {
    return m_protein;
}
void OAISearchRecipes_200_response_results_inner::setProtein(const QString &protein) {
    m_protein = protein;
    m_protein_isSet = true;
}

bool OAISearchRecipes_200_response_results_inner::is_protein_Set() const{
    return m_protein_isSet;
}

bool OAISearchRecipes_200_response_results_inner::is_protein_Valid() const{
    return m_protein_isValid;
}

bool OAISearchRecipes_200_response_results_inner::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_id_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_title_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_calories_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_carbs_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_fat_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_image_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_image_type_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_protein_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAISearchRecipes_200_response_results_inner::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_id_isValid && m_title_isValid && m_calories_isValid && m_carbs_isValid && m_fat_isValid && m_image_isValid && m_image_type_isValid && m_protein_isValid && true;
}

} // namespace OpenAPI
