/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/*
 * OAISearchRestaurants_200_response_restaurants_inner_local_hours.h
 *
 * 
 */

#ifndef OAISearchRestaurants_200_response_restaurants_inner_local_hours_H
#define OAISearchRestaurants_200_response_restaurants_inner_local_hours_H

#include <QJsonObject>

#include "OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational.h"

#include "OAIEnum.h"
#include "OAIObject.h"

namespace OpenAPI {
class OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational;

class OAISearchRestaurants_200_response_restaurants_inner_local_hours : public OAIObject {
public:
    OAISearchRestaurants_200_response_restaurants_inner_local_hours();
    OAISearchRestaurants_200_response_restaurants_inner_local_hours(QString json);
    ~OAISearchRestaurants_200_response_restaurants_inner_local_hours() override;

    QString asJson() const override;
    QJsonObject asJsonObject() const override;
    void fromJsonObject(QJsonObject json) override;
    void fromJson(QString jsonString) override;

    OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational getOperational() const;
    void setOperational(const OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational &operational);
    bool is_operational_Set() const;
    bool is_operational_Valid() const;

    OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational getDelivery() const;
    void setDelivery(const OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational &delivery);
    bool is_delivery_Set() const;
    bool is_delivery_Valid() const;

    OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational getPickup() const;
    void setPickup(const OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational &pickup);
    bool is_pickup_Set() const;
    bool is_pickup_Valid() const;

    OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational getDineIn() const;
    void setDineIn(const OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational &dine_in);
    bool is_dine_in_Set() const;
    bool is_dine_in_Valid() const;

    virtual bool isSet() const override;
    virtual bool isValid() const override;

private:
    void initializeModel();

    OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational m_operational;
    bool m_operational_isSet;
    bool m_operational_isValid;

    OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational m_delivery;
    bool m_delivery_isSet;
    bool m_delivery_isValid;

    OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational m_pickup;
    bool m_pickup_isSet;
    bool m_pickup_isValid;

    OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational m_dine_in;
    bool m_dine_in_isSet;
    bool m_dine_in_isValid;
};

} // namespace OpenAPI

Q_DECLARE_METATYPE(OpenAPI::OAISearchRestaurants_200_response_restaurants_inner_local_hours)

#endif // OAISearchRestaurants_200_response_restaurants_inner_local_hours_H
