/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational() {
    this->initializeModel();
}

OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::~OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational() {}

void OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::initializeModel() {

    m_monday_isSet = false;
    m_monday_isValid = false;

    m_tuesday_isSet = false;
    m_tuesday_isValid = false;

    m_wednesday_isSet = false;
    m_wednesday_isValid = false;

    m_thursday_isSet = false;
    m_thursday_isValid = false;

    m_friday_isSet = false;
    m_friday_isValid = false;

    m_saturday_isSet = false;
    m_saturday_isValid = false;

    m_sunday_isSet = false;
    m_sunday_isValid = false;
}

void OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::fromJsonObject(QJsonObject json) {

    m_monday_isValid = ::OpenAPI::fromJsonValue(m_monday, json[QString("Monday")]);
    m_monday_isSet = !json[QString("Monday")].isNull() && m_monday_isValid;

    m_tuesday_isValid = ::OpenAPI::fromJsonValue(m_tuesday, json[QString("Tuesday")]);
    m_tuesday_isSet = !json[QString("Tuesday")].isNull() && m_tuesday_isValid;

    m_wednesday_isValid = ::OpenAPI::fromJsonValue(m_wednesday, json[QString("Wednesday")]);
    m_wednesday_isSet = !json[QString("Wednesday")].isNull() && m_wednesday_isValid;

    m_thursday_isValid = ::OpenAPI::fromJsonValue(m_thursday, json[QString("Thursday")]);
    m_thursday_isSet = !json[QString("Thursday")].isNull() && m_thursday_isValid;

    m_friday_isValid = ::OpenAPI::fromJsonValue(m_friday, json[QString("Friday")]);
    m_friday_isSet = !json[QString("Friday")].isNull() && m_friday_isValid;

    m_saturday_isValid = ::OpenAPI::fromJsonValue(m_saturday, json[QString("Saturday")]);
    m_saturday_isSet = !json[QString("Saturday")].isNull() && m_saturday_isValid;

    m_sunday_isValid = ::OpenAPI::fromJsonValue(m_sunday, json[QString("Sunday")]);
    m_sunday_isSet = !json[QString("Sunday")].isNull() && m_sunday_isValid;
}

QString OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::asJsonObject() const {
    QJsonObject obj;
    if (m_monday_isSet) {
        obj.insert(QString("Monday"), ::OpenAPI::toJsonValue(m_monday));
    }
    if (m_tuesday_isSet) {
        obj.insert(QString("Tuesday"), ::OpenAPI::toJsonValue(m_tuesday));
    }
    if (m_wednesday_isSet) {
        obj.insert(QString("Wednesday"), ::OpenAPI::toJsonValue(m_wednesday));
    }
    if (m_thursday_isSet) {
        obj.insert(QString("Thursday"), ::OpenAPI::toJsonValue(m_thursday));
    }
    if (m_friday_isSet) {
        obj.insert(QString("Friday"), ::OpenAPI::toJsonValue(m_friday));
    }
    if (m_saturday_isSet) {
        obj.insert(QString("Saturday"), ::OpenAPI::toJsonValue(m_saturday));
    }
    if (m_sunday_isSet) {
        obj.insert(QString("Sunday"), ::OpenAPI::toJsonValue(m_sunday));
    }
    return obj;
}

QString OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::getMonday() const {
    return m_monday;
}
void OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::setMonday(const QString &monday) {
    m_monday = monday;
    m_monday_isSet = true;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_monday_Set() const{
    return m_monday_isSet;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_monday_Valid() const{
    return m_monday_isValid;
}

QString OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::getTuesday() const {
    return m_tuesday;
}
void OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::setTuesday(const QString &tuesday) {
    m_tuesday = tuesday;
    m_tuesday_isSet = true;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_tuesday_Set() const{
    return m_tuesday_isSet;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_tuesday_Valid() const{
    return m_tuesday_isValid;
}

QString OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::getWednesday() const {
    return m_wednesday;
}
void OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::setWednesday(const QString &wednesday) {
    m_wednesday = wednesday;
    m_wednesday_isSet = true;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_wednesday_Set() const{
    return m_wednesday_isSet;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_wednesday_Valid() const{
    return m_wednesday_isValid;
}

QString OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::getThursday() const {
    return m_thursday;
}
void OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::setThursday(const QString &thursday) {
    m_thursday = thursday;
    m_thursday_isSet = true;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_thursday_Set() const{
    return m_thursday_isSet;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_thursday_Valid() const{
    return m_thursday_isValid;
}

QString OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::getFriday() const {
    return m_friday;
}
void OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::setFriday(const QString &friday) {
    m_friday = friday;
    m_friday_isSet = true;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_friday_Set() const{
    return m_friday_isSet;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_friday_Valid() const{
    return m_friday_isValid;
}

QString OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::getSaturday() const {
    return m_saturday;
}
void OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::setSaturday(const QString &saturday) {
    m_saturday = saturday;
    m_saturday_isSet = true;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_saturday_Set() const{
    return m_saturday_isSet;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_saturday_Valid() const{
    return m_saturday_isValid;
}

QString OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::getSunday() const {
    return m_sunday;
}
void OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::setSunday(const QString &sunday) {
    m_sunday = sunday;
    m_sunday_isSet = true;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_sunday_Set() const{
    return m_sunday_isSet;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::is_sunday_Valid() const{
    return m_sunday_isValid;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_monday_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_tuesday_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_wednesday_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_thursday_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_friday_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_saturday_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_sunday_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAISearchRestaurants_200_response_restaurants_inner_local_hours_operational::isValid() const {
    // only required properties are required for the object to be considered valid
    return true;
}

} // namespace OpenAPI
