/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAISummarizeRecipe_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAISummarizeRecipe_200_response::OAISummarizeRecipe_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAISummarizeRecipe_200_response::OAISummarizeRecipe_200_response() {
    this->initializeModel();
}

OAISummarizeRecipe_200_response::~OAISummarizeRecipe_200_response() {}

void OAISummarizeRecipe_200_response::initializeModel() {

    m_id_isSet = false;
    m_id_isValid = false;

    m_summary_isSet = false;
    m_summary_isValid = false;

    m_title_isSet = false;
    m_title_isValid = false;
}

void OAISummarizeRecipe_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAISummarizeRecipe_200_response::fromJsonObject(QJsonObject json) {

    m_id_isValid = ::OpenAPI::fromJsonValue(m_id, json[QString("id")]);
    m_id_isSet = !json[QString("id")].isNull() && m_id_isValid;

    m_summary_isValid = ::OpenAPI::fromJsonValue(m_summary, json[QString("summary")]);
    m_summary_isSet = !json[QString("summary")].isNull() && m_summary_isValid;

    m_title_isValid = ::OpenAPI::fromJsonValue(m_title, json[QString("title")]);
    m_title_isSet = !json[QString("title")].isNull() && m_title_isValid;
}

QString OAISummarizeRecipe_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAISummarizeRecipe_200_response::asJsonObject() const {
    QJsonObject obj;
    if (m_id_isSet) {
        obj.insert(QString("id"), ::OpenAPI::toJsonValue(m_id));
    }
    if (m_summary_isSet) {
        obj.insert(QString("summary"), ::OpenAPI::toJsonValue(m_summary));
    }
    if (m_title_isSet) {
        obj.insert(QString("title"), ::OpenAPI::toJsonValue(m_title));
    }
    return obj;
}

qint32 OAISummarizeRecipe_200_response::getId() const {
    return m_id;
}
void OAISummarizeRecipe_200_response::setId(const qint32 &id) {
    m_id = id;
    m_id_isSet = true;
}

bool OAISummarizeRecipe_200_response::is_id_Set() const{
    return m_id_isSet;
}

bool OAISummarizeRecipe_200_response::is_id_Valid() const{
    return m_id_isValid;
}

QString OAISummarizeRecipe_200_response::getSummary() const {
    return m_summary;
}
void OAISummarizeRecipe_200_response::setSummary(const QString &summary) {
    m_summary = summary;
    m_summary_isSet = true;
}

bool OAISummarizeRecipe_200_response::is_summary_Set() const{
    return m_summary_isSet;
}

bool OAISummarizeRecipe_200_response::is_summary_Valid() const{
    return m_summary_isValid;
}

QString OAISummarizeRecipe_200_response::getTitle() const {
    return m_title;
}
void OAISummarizeRecipe_200_response::setTitle(const QString &title) {
    m_title = title;
    m_title_isSet = true;
}

bool OAISummarizeRecipe_200_response::is_title_Set() const{
    return m_title_isSet;
}

bool OAISummarizeRecipe_200_response::is_title_Valid() const{
    return m_title_isValid;
}

bool OAISummarizeRecipe_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_id_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_summary_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_title_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAISummarizeRecipe_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_id_isValid && m_summary_isValid && m_title_isValid && true;
}

} // namespace OpenAPI
