/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIAddMealPlanTemplate_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIAddMealPlanTemplate_200_response::OAIAddMealPlanTemplate_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIAddMealPlanTemplate_200_response::OAIAddMealPlanTemplate_200_response() {
    this->initializeModel();
}

OAIAddMealPlanTemplate_200_response::~OAIAddMealPlanTemplate_200_response() {}

void OAIAddMealPlanTemplate_200_response::initializeModel() {

    m_name_isSet = false;
    m_name_isValid = false;

    m_items_isSet = false;
    m_items_isValid = false;

    m_publish_as_public_isSet = false;
    m_publish_as_public_isValid = false;
}

void OAIAddMealPlanTemplate_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIAddMealPlanTemplate_200_response::fromJsonObject(QJsonObject json) {

    m_name_isValid = ::OpenAPI::fromJsonValue(name, json[QString("name")]);
    m_name_isSet = !json[QString("name")].isNull() && m_name_isValid;

    m_items_isValid = ::OpenAPI::fromJsonValue(items, json[QString("items")]);
    m_items_isSet = !json[QString("items")].isNull() && m_items_isValid;

    m_publish_as_public_isValid = ::OpenAPI::fromJsonValue(publish_as_public, json[QString("publishAsPublic")]);
    m_publish_as_public_isSet = !json[QString("publishAsPublic")].isNull() && m_publish_as_public_isValid;
}

QString OAIAddMealPlanTemplate_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIAddMealPlanTemplate_200_response::asJsonObject() const {
    QJsonObject obj;
    if (m_name_isSet) {
        obj.insert(QString("name"), ::OpenAPI::toJsonValue(name));
    }
    if (items.size() > 0) {
        obj.insert(QString("items"), ::OpenAPI::toJsonValue(items));
    }
    if (m_publish_as_public_isSet) {
        obj.insert(QString("publishAsPublic"), ::OpenAPI::toJsonValue(publish_as_public));
    }
    return obj;
}

QString OAIAddMealPlanTemplate_200_response::getName() const {
    return name;
}
void OAIAddMealPlanTemplate_200_response::setName(const QString &name) {
    this->name = name;
    this->m_name_isSet = true;
}

bool OAIAddMealPlanTemplate_200_response::is_name_Set() const{
    return m_name_isSet;
}

bool OAIAddMealPlanTemplate_200_response::is_name_Valid() const{
    return m_name_isValid;
}

QSet<OAIAddMealPlanTemplate_200_response_items_inner> OAIAddMealPlanTemplate_200_response::getItems() const {
    return items;
}
void OAIAddMealPlanTemplate_200_response::setItems(const QSet<OAIAddMealPlanTemplate_200_response_items_inner> &items) {
    this->items = items;
    this->m_items_isSet = true;
}

bool OAIAddMealPlanTemplate_200_response::is_items_Set() const{
    return m_items_isSet;
}

bool OAIAddMealPlanTemplate_200_response::is_items_Valid() const{
    return m_items_isValid;
}

bool OAIAddMealPlanTemplate_200_response::isPublishAsPublic() const {
    return publish_as_public;
}
void OAIAddMealPlanTemplate_200_response::setPublishAsPublic(const bool &publish_as_public) {
    this->publish_as_public = publish_as_public;
    this->m_publish_as_public_isSet = true;
}

bool OAIAddMealPlanTemplate_200_response::is_publish_as_public_Set() const{
    return m_publish_as_public_isSet;
}

bool OAIAddMealPlanTemplate_200_response::is_publish_as_public_Valid() const{
    return m_publish_as_public_isValid;
}

bool OAIAddMealPlanTemplate_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_name_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (items.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (m_publish_as_public_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIAddMealPlanTemplate_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_name_isValid && m_items_isValid && m_publish_as_public_isValid && true;
}

} // namespace OpenAPI
