/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIAnalyzeARecipeSearchQuery_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIAnalyzeARecipeSearchQuery_200_response::OAIAnalyzeARecipeSearchQuery_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIAnalyzeARecipeSearchQuery_200_response::OAIAnalyzeARecipeSearchQuery_200_response() {
    this->initializeModel();
}

OAIAnalyzeARecipeSearchQuery_200_response::~OAIAnalyzeARecipeSearchQuery_200_response() {}

void OAIAnalyzeARecipeSearchQuery_200_response::initializeModel() {

    m_dishes_isSet = false;
    m_dishes_isValid = false;

    m_ingredients_isSet = false;
    m_ingredients_isValid = false;

    m_cuisines_isSet = false;
    m_cuisines_isValid = false;

    m_modifiers_isSet = false;
    m_modifiers_isValid = false;
}

void OAIAnalyzeARecipeSearchQuery_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIAnalyzeARecipeSearchQuery_200_response::fromJsonObject(QJsonObject json) {

    m_dishes_isValid = ::OpenAPI::fromJsonValue(dishes, json[QString("dishes")]);
    m_dishes_isSet = !json[QString("dishes")].isNull() && m_dishes_isValid;

    m_ingredients_isValid = ::OpenAPI::fromJsonValue(ingredients, json[QString("ingredients")]);
    m_ingredients_isSet = !json[QString("ingredients")].isNull() && m_ingredients_isValid;

    m_cuisines_isValid = ::OpenAPI::fromJsonValue(cuisines, json[QString("cuisines")]);
    m_cuisines_isSet = !json[QString("cuisines")].isNull() && m_cuisines_isValid;

    m_modifiers_isValid = ::OpenAPI::fromJsonValue(modifiers, json[QString("modifiers")]);
    m_modifiers_isSet = !json[QString("modifiers")].isNull() && m_modifiers_isValid;
}

QString OAIAnalyzeARecipeSearchQuery_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIAnalyzeARecipeSearchQuery_200_response::asJsonObject() const {
    QJsonObject obj;
    if (dishes.size() > 0) {
        obj.insert(QString("dishes"), ::OpenAPI::toJsonValue(dishes));
    }
    if (ingredients.size() > 0) {
        obj.insert(QString("ingredients"), ::OpenAPI::toJsonValue(ingredients));
    }
    if (cuisines.size() > 0) {
        obj.insert(QString("cuisines"), ::OpenAPI::toJsonValue(cuisines));
    }
    if (modifiers.size() > 0) {
        obj.insert(QString("modifiers"), ::OpenAPI::toJsonValue(modifiers));
    }
    return obj;
}

QSet<OAIAnalyzeARecipeSearchQuery_200_response_dishes_inner> OAIAnalyzeARecipeSearchQuery_200_response::getDishes() const {
    return dishes;
}
void OAIAnalyzeARecipeSearchQuery_200_response::setDishes(const QSet<OAIAnalyzeARecipeSearchQuery_200_response_dishes_inner> &dishes) {
    this->dishes = dishes;
    this->m_dishes_isSet = true;
}

bool OAIAnalyzeARecipeSearchQuery_200_response::is_dishes_Set() const{
    return m_dishes_isSet;
}

bool OAIAnalyzeARecipeSearchQuery_200_response::is_dishes_Valid() const{
    return m_dishes_isValid;
}

QSet<OAIAnalyzeARecipeSearchQuery_200_response_ingredients_inner> OAIAnalyzeARecipeSearchQuery_200_response::getIngredients() const {
    return ingredients;
}
void OAIAnalyzeARecipeSearchQuery_200_response::setIngredients(const QSet<OAIAnalyzeARecipeSearchQuery_200_response_ingredients_inner> &ingredients) {
    this->ingredients = ingredients;
    this->m_ingredients_isSet = true;
}

bool OAIAnalyzeARecipeSearchQuery_200_response::is_ingredients_Set() const{
    return m_ingredients_isSet;
}

bool OAIAnalyzeARecipeSearchQuery_200_response::is_ingredients_Valid() const{
    return m_ingredients_isValid;
}

QList<QString> OAIAnalyzeARecipeSearchQuery_200_response::getCuisines() const {
    return cuisines;
}
void OAIAnalyzeARecipeSearchQuery_200_response::setCuisines(const QList<QString> &cuisines) {
    this->cuisines = cuisines;
    this->m_cuisines_isSet = true;
}

bool OAIAnalyzeARecipeSearchQuery_200_response::is_cuisines_Set() const{
    return m_cuisines_isSet;
}

bool OAIAnalyzeARecipeSearchQuery_200_response::is_cuisines_Valid() const{
    return m_cuisines_isValid;
}

QList<QString> OAIAnalyzeARecipeSearchQuery_200_response::getModifiers() const {
    return modifiers;
}
void OAIAnalyzeARecipeSearchQuery_200_response::setModifiers(const QList<QString> &modifiers) {
    this->modifiers = modifiers;
    this->m_modifiers_isSet = true;
}

bool OAIAnalyzeARecipeSearchQuery_200_response::is_modifiers_Set() const{
    return m_modifiers_isSet;
}

bool OAIAnalyzeARecipeSearchQuery_200_response::is_modifiers_Valid() const{
    return m_modifiers_isValid;
}

bool OAIAnalyzeARecipeSearchQuery_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (dishes.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (ingredients.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (cuisines.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (modifiers.size() > 0) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIAnalyzeARecipeSearchQuery_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_dishes_isValid && m_ingredients_isValid && m_cuisines_isValid && m_modifiers_isValid && true;
}

} // namespace OpenAPI
