/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIAnalyzeRecipeInstructions_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIAnalyzeRecipeInstructions_200_response::OAIAnalyzeRecipeInstructions_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIAnalyzeRecipeInstructions_200_response::OAIAnalyzeRecipeInstructions_200_response() {
    this->initializeModel();
}

OAIAnalyzeRecipeInstructions_200_response::~OAIAnalyzeRecipeInstructions_200_response() {}

void OAIAnalyzeRecipeInstructions_200_response::initializeModel() {

    m_parsed_instructions_isSet = false;
    m_parsed_instructions_isValid = false;

    m_ingredients_isSet = false;
    m_ingredients_isValid = false;

    m_equipment_isSet = false;
    m_equipment_isValid = false;
}

void OAIAnalyzeRecipeInstructions_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIAnalyzeRecipeInstructions_200_response::fromJsonObject(QJsonObject json) {

    m_parsed_instructions_isValid = ::OpenAPI::fromJsonValue(parsed_instructions, json[QString("parsedInstructions")]);
    m_parsed_instructions_isSet = !json[QString("parsedInstructions")].isNull() && m_parsed_instructions_isValid;

    m_ingredients_isValid = ::OpenAPI::fromJsonValue(ingredients, json[QString("ingredients")]);
    m_ingredients_isSet = !json[QString("ingredients")].isNull() && m_ingredients_isValid;

    m_equipment_isValid = ::OpenAPI::fromJsonValue(equipment, json[QString("equipment")]);
    m_equipment_isSet = !json[QString("equipment")].isNull() && m_equipment_isValid;
}

QString OAIAnalyzeRecipeInstructions_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIAnalyzeRecipeInstructions_200_response::asJsonObject() const {
    QJsonObject obj;
    if (parsed_instructions.size() > 0) {
        obj.insert(QString("parsedInstructions"), ::OpenAPI::toJsonValue(parsed_instructions));
    }
    if (ingredients.size() > 0) {
        obj.insert(QString("ingredients"), ::OpenAPI::toJsonValue(ingredients));
    }
    if (equipment.size() > 0) {
        obj.insert(QString("equipment"), ::OpenAPI::toJsonValue(equipment));
    }
    return obj;
}

QSet<OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner> OAIAnalyzeRecipeInstructions_200_response::getParsedInstructions() const {
    return parsed_instructions;
}
void OAIAnalyzeRecipeInstructions_200_response::setParsedInstructions(const QSet<OAIAnalyzeRecipeInstructions_200_response_parsedInstructions_inner> &parsed_instructions) {
    this->parsed_instructions = parsed_instructions;
    this->m_parsed_instructions_isSet = true;
}

bool OAIAnalyzeRecipeInstructions_200_response::is_parsed_instructions_Set() const{
    return m_parsed_instructions_isSet;
}

bool OAIAnalyzeRecipeInstructions_200_response::is_parsed_instructions_Valid() const{
    return m_parsed_instructions_isValid;
}

QSet<OAIAnalyzeRecipeInstructions_200_response_ingredients_inner> OAIAnalyzeRecipeInstructions_200_response::getIngredients() const {
    return ingredients;
}
void OAIAnalyzeRecipeInstructions_200_response::setIngredients(const QSet<OAIAnalyzeRecipeInstructions_200_response_ingredients_inner> &ingredients) {
    this->ingredients = ingredients;
    this->m_ingredients_isSet = true;
}

bool OAIAnalyzeRecipeInstructions_200_response::is_ingredients_Set() const{
    return m_ingredients_isSet;
}

bool OAIAnalyzeRecipeInstructions_200_response::is_ingredients_Valid() const{
    return m_ingredients_isValid;
}

QSet<OAIAnalyzeRecipeInstructions_200_response_ingredients_inner> OAIAnalyzeRecipeInstructions_200_response::getEquipment() const {
    return equipment;
}
void OAIAnalyzeRecipeInstructions_200_response::setEquipment(const QSet<OAIAnalyzeRecipeInstructions_200_response_ingredients_inner> &equipment) {
    this->equipment = equipment;
    this->m_equipment_isSet = true;
}

bool OAIAnalyzeRecipeInstructions_200_response::is_equipment_Set() const{
    return m_equipment_isSet;
}

bool OAIAnalyzeRecipeInstructions_200_response::is_equipment_Valid() const{
    return m_equipment_isValid;
}

bool OAIAnalyzeRecipeInstructions_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (parsed_instructions.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (ingredients.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (equipment.size() > 0) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIAnalyzeRecipeInstructions_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_parsed_instructions_isValid && m_ingredients_isValid && m_equipment_isValid && true;
}

} // namespace OpenAPI
