/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIAutocompleteProductSearch_200_response_results_inner.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIAutocompleteProductSearch_200_response_results_inner::OAIAutocompleteProductSearch_200_response_results_inner(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIAutocompleteProductSearch_200_response_results_inner::OAIAutocompleteProductSearch_200_response_results_inner() {
    this->initializeModel();
}

OAIAutocompleteProductSearch_200_response_results_inner::~OAIAutocompleteProductSearch_200_response_results_inner() {}

void OAIAutocompleteProductSearch_200_response_results_inner::initializeModel() {

    m_id_isSet = false;
    m_id_isValid = false;

    m_title_isSet = false;
    m_title_isValid = false;
}

void OAIAutocompleteProductSearch_200_response_results_inner::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIAutocompleteProductSearch_200_response_results_inner::fromJsonObject(QJsonObject json) {

    m_id_isValid = ::OpenAPI::fromJsonValue(id, json[QString("id")]);
    m_id_isSet = !json[QString("id")].isNull() && m_id_isValid;

    m_title_isValid = ::OpenAPI::fromJsonValue(title, json[QString("title")]);
    m_title_isSet = !json[QString("title")].isNull() && m_title_isValid;
}

QString OAIAutocompleteProductSearch_200_response_results_inner::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIAutocompleteProductSearch_200_response_results_inner::asJsonObject() const {
    QJsonObject obj;
    if (m_id_isSet) {
        obj.insert(QString("id"), ::OpenAPI::toJsonValue(id));
    }
    if (m_title_isSet) {
        obj.insert(QString("title"), ::OpenAPI::toJsonValue(title));
    }
    return obj;
}

qint32 OAIAutocompleteProductSearch_200_response_results_inner::getId() const {
    return id;
}
void OAIAutocompleteProductSearch_200_response_results_inner::setId(const qint32 &id) {
    this->id = id;
    this->m_id_isSet = true;
}

bool OAIAutocompleteProductSearch_200_response_results_inner::is_id_Set() const{
    return m_id_isSet;
}

bool OAIAutocompleteProductSearch_200_response_results_inner::is_id_Valid() const{
    return m_id_isValid;
}

QString OAIAutocompleteProductSearch_200_response_results_inner::getTitle() const {
    return title;
}
void OAIAutocompleteProductSearch_200_response_results_inner::setTitle(const QString &title) {
    this->title = title;
    this->m_title_isSet = true;
}

bool OAIAutocompleteProductSearch_200_response_results_inner::is_title_Set() const{
    return m_title_isSet;
}

bool OAIAutocompleteProductSearch_200_response_results_inner::is_title_Valid() const{
    return m_title_isValid;
}

bool OAIAutocompleteProductSearch_200_response_results_inner::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_id_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_title_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIAutocompleteProductSearch_200_response_results_inner::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_id_isValid && m_title_isValid && true;
}

} // namespace OpenAPI
