/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIGenerateMealPlan_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIGenerateMealPlan_200_response::OAIGenerateMealPlan_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIGenerateMealPlan_200_response::OAIGenerateMealPlan_200_response() {
    this->initializeModel();
}

OAIGenerateMealPlan_200_response::~OAIGenerateMealPlan_200_response() {}

void OAIGenerateMealPlan_200_response::initializeModel() {

    m_meals_isSet = false;
    m_meals_isValid = false;

    m_nutrients_isSet = false;
    m_nutrients_isValid = false;
}

void OAIGenerateMealPlan_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIGenerateMealPlan_200_response::fromJsonObject(QJsonObject json) {

    m_meals_isValid = ::OpenAPI::fromJsonValue(meals, json[QString("meals")]);
    m_meals_isSet = !json[QString("meals")].isNull() && m_meals_isValid;

    m_nutrients_isValid = ::OpenAPI::fromJsonValue(nutrients, json[QString("nutrients")]);
    m_nutrients_isSet = !json[QString("nutrients")].isNull() && m_nutrients_isValid;
}

QString OAIGenerateMealPlan_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIGenerateMealPlan_200_response::asJsonObject() const {
    QJsonObject obj;
    if (meals.size() > 0) {
        obj.insert(QString("meals"), ::OpenAPI::toJsonValue(meals));
    }
    if (nutrients.isSet()) {
        obj.insert(QString("nutrients"), ::OpenAPI::toJsonValue(nutrients));
    }
    return obj;
}

QSet<OAIGetSimilarRecipes_200_response_inner> OAIGenerateMealPlan_200_response::getMeals() const {
    return meals;
}
void OAIGenerateMealPlan_200_response::setMeals(const QSet<OAIGetSimilarRecipes_200_response_inner> &meals) {
    this->meals = meals;
    this->m_meals_isSet = true;
}

bool OAIGenerateMealPlan_200_response::is_meals_Set() const{
    return m_meals_isSet;
}

bool OAIGenerateMealPlan_200_response::is_meals_Valid() const{
    return m_meals_isValid;
}

OAIGenerateMealPlan_200_response_nutrients OAIGenerateMealPlan_200_response::getNutrients() const {
    return nutrients;
}
void OAIGenerateMealPlan_200_response::setNutrients(const OAIGenerateMealPlan_200_response_nutrients &nutrients) {
    this->nutrients = nutrients;
    this->m_nutrients_isSet = true;
}

bool OAIGenerateMealPlan_200_response::is_nutrients_Set() const{
    return m_nutrients_isSet;
}

bool OAIGenerateMealPlan_200_response::is_nutrients_Valid() const{
    return m_nutrients_isValid;
}

bool OAIGenerateMealPlan_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (meals.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (nutrients.isSet()) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIGenerateMealPlan_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_meals_isValid && m_nutrients_isValid && true;
}

} // namespace OpenAPI
