/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIGetComparableProducts_200_response_comparableProducts.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIGetComparableProducts_200_response_comparableProducts::OAIGetComparableProducts_200_response_comparableProducts(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIGetComparableProducts_200_response_comparableProducts::OAIGetComparableProducts_200_response_comparableProducts() {
    this->initializeModel();
}

OAIGetComparableProducts_200_response_comparableProducts::~OAIGetComparableProducts_200_response_comparableProducts() {}

void OAIGetComparableProducts_200_response_comparableProducts::initializeModel() {

    m_calories_isSet = false;
    m_calories_isValid = false;

    m_likes_isSet = false;
    m_likes_isValid = false;

    m_price_isSet = false;
    m_price_isValid = false;

    m_protein_isSet = false;
    m_protein_isValid = false;

    m_spoonacular_score_isSet = false;
    m_spoonacular_score_isValid = false;

    m_sugar_isSet = false;
    m_sugar_isValid = false;
}

void OAIGetComparableProducts_200_response_comparableProducts::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIGetComparableProducts_200_response_comparableProducts::fromJsonObject(QJsonObject json) {

    m_calories_isValid = ::OpenAPI::fromJsonValue(calories, json[QString("calories")]);
    m_calories_isSet = !json[QString("calories")].isNull() && m_calories_isValid;

    m_likes_isValid = ::OpenAPI::fromJsonValue(likes, json[QString("likes")]);
    m_likes_isSet = !json[QString("likes")].isNull() && m_likes_isValid;

    m_price_isValid = ::OpenAPI::fromJsonValue(price, json[QString("price")]);
    m_price_isSet = !json[QString("price")].isNull() && m_price_isValid;

    m_protein_isValid = ::OpenAPI::fromJsonValue(protein, json[QString("protein")]);
    m_protein_isSet = !json[QString("protein")].isNull() && m_protein_isValid;

    m_spoonacular_score_isValid = ::OpenAPI::fromJsonValue(spoonacular_score, json[QString("spoonacularScore")]);
    m_spoonacular_score_isSet = !json[QString("spoonacularScore")].isNull() && m_spoonacular_score_isValid;

    m_sugar_isValid = ::OpenAPI::fromJsonValue(sugar, json[QString("sugar")]);
    m_sugar_isSet = !json[QString("sugar")].isNull() && m_sugar_isValid;
}

QString OAIGetComparableProducts_200_response_comparableProducts::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIGetComparableProducts_200_response_comparableProducts::asJsonObject() const {
    QJsonObject obj;
    if (calories.size() > 0) {
        obj.insert(QString("calories"), ::OpenAPI::toJsonValue(calories));
    }
    if (likes.size() > 0) {
        obj.insert(QString("likes"), ::OpenAPI::toJsonValue(likes));
    }
    if (price.size() > 0) {
        obj.insert(QString("price"), ::OpenAPI::toJsonValue(price));
    }
    if (protein.size() > 0) {
        obj.insert(QString("protein"), ::OpenAPI::toJsonValue(protein));
    }
    if (spoonacular_score.size() > 0) {
        obj.insert(QString("spoonacularScore"), ::OpenAPI::toJsonValue(spoonacular_score));
    }
    if (sugar.size() > 0) {
        obj.insert(QString("sugar"), ::OpenAPI::toJsonValue(sugar));
    }
    return obj;
}

QList<OAIObject> OAIGetComparableProducts_200_response_comparableProducts::getCalories() const {
    return calories;
}
void OAIGetComparableProducts_200_response_comparableProducts::setCalories(const QList<OAIObject> &calories) {
    this->calories = calories;
    this->m_calories_isSet = true;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_calories_Set() const{
    return m_calories_isSet;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_calories_Valid() const{
    return m_calories_isValid;
}

QList<OAIObject> OAIGetComparableProducts_200_response_comparableProducts::getLikes() const {
    return likes;
}
void OAIGetComparableProducts_200_response_comparableProducts::setLikes(const QList<OAIObject> &likes) {
    this->likes = likes;
    this->m_likes_isSet = true;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_likes_Set() const{
    return m_likes_isSet;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_likes_Valid() const{
    return m_likes_isValid;
}

QList<OAIObject> OAIGetComparableProducts_200_response_comparableProducts::getPrice() const {
    return price;
}
void OAIGetComparableProducts_200_response_comparableProducts::setPrice(const QList<OAIObject> &price) {
    this->price = price;
    this->m_price_isSet = true;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_price_Set() const{
    return m_price_isSet;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_price_Valid() const{
    return m_price_isValid;
}

QSet<OAIGetComparableProducts_200_response_comparableProducts_protein_inner> OAIGetComparableProducts_200_response_comparableProducts::getProtein() const {
    return protein;
}
void OAIGetComparableProducts_200_response_comparableProducts::setProtein(const QSet<OAIGetComparableProducts_200_response_comparableProducts_protein_inner> &protein) {
    this->protein = protein;
    this->m_protein_isSet = true;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_protein_Set() const{
    return m_protein_isSet;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_protein_Valid() const{
    return m_protein_isValid;
}

QSet<OAIGetComparableProducts_200_response_comparableProducts_protein_inner> OAIGetComparableProducts_200_response_comparableProducts::getSpoonacularScore() const {
    return spoonacular_score;
}
void OAIGetComparableProducts_200_response_comparableProducts::setSpoonacularScore(const QSet<OAIGetComparableProducts_200_response_comparableProducts_protein_inner> &spoonacular_score) {
    this->spoonacular_score = spoonacular_score;
    this->m_spoonacular_score_isSet = true;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_spoonacular_score_Set() const{
    return m_spoonacular_score_isSet;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_spoonacular_score_Valid() const{
    return m_spoonacular_score_isValid;
}

QList<OAIObject> OAIGetComparableProducts_200_response_comparableProducts::getSugar() const {
    return sugar;
}
void OAIGetComparableProducts_200_response_comparableProducts::setSugar(const QList<OAIObject> &sugar) {
    this->sugar = sugar;
    this->m_sugar_isSet = true;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_sugar_Set() const{
    return m_sugar_isSet;
}

bool OAIGetComparableProducts_200_response_comparableProducts::is_sugar_Valid() const{
    return m_sugar_isValid;
}

bool OAIGetComparableProducts_200_response_comparableProducts::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (calories.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (likes.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (price.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (protein.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (spoonacular_score.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (sugar.size() > 0) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIGetComparableProducts_200_response_comparableProducts::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_calories_isValid && m_likes_isValid && m_price_isValid && m_protein_isValid && m_spoonacular_score_isValid && m_sugar_isValid && true;
}

} // namespace OpenAPI
