/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIGetConversationSuggests_200_response_suggests.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIGetConversationSuggests_200_response_suggests::OAIGetConversationSuggests_200_response_suggests(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIGetConversationSuggests_200_response_suggests::OAIGetConversationSuggests_200_response_suggests() {
    this->initializeModel();
}

OAIGetConversationSuggests_200_response_suggests::~OAIGetConversationSuggests_200_response_suggests() {}

void OAIGetConversationSuggests_200_response_suggests::initializeModel() {

    m___isSet = false;
    m___isValid = false;
}

void OAIGetConversationSuggests_200_response_suggests::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIGetConversationSuggests_200_response_suggests::fromJsonObject(QJsonObject json) {

    m___isValid = ::OpenAPI::fromJsonValue(_, json[QString("_")]);
    m___isSet = !json[QString("_")].isNull() && m___isValid;
}

QString OAIGetConversationSuggests_200_response_suggests::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIGetConversationSuggests_200_response_suggests::asJsonObject() const {
    QJsonObject obj;
    if (_.size() > 0) {
        obj.insert(QString("_"), ::OpenAPI::toJsonValue(_));
    }
    return obj;
}

QSet<OAIGetConversationSuggests_200_response_suggests___inner> OAIGetConversationSuggests_200_response_suggests::get() const {
    return _;
}
void OAIGetConversationSuggests_200_response_suggests::set(const QSet<OAIGetConversationSuggests_200_response_suggests___inner> &_) {
    this->_ = _;
    this->m___isSet = true;
}

bool OAIGetConversationSuggests_200_response_suggests::is___Set() const{
    return m___isSet;
}

bool OAIGetConversationSuggests_200_response_suggests::is___Valid() const{
    return m___isValid;
}

bool OAIGetConversationSuggests_200_response_suggests::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (_.size() > 0) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIGetConversationSuggests_200_response_suggests::isValid() const {
    // only required properties are required for the object to be considered valid
    return m___isValid && true;
}

} // namespace OpenAPI
