/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/*
 * OAIGetIngredientSubstitutes_200_response.h
 *
 * 
 */

#ifndef OAIGetIngredientSubstitutes_200_response_H
#define OAIGetIngredientSubstitutes_200_response_H

#include <QJsonObject>

#include <QList>
#include <QString>

#include "OAIEnum.h"
#include "OAIObject.h"

namespace OpenAPI {

class OAIGetIngredientSubstitutes_200_response : public OAIObject {
public:
    OAIGetIngredientSubstitutes_200_response();
    OAIGetIngredientSubstitutes_200_response(QString json);
    ~OAIGetIngredientSubstitutes_200_response() override;

    QString asJson() const override;
    QJsonObject asJsonObject() const override;
    void fromJsonObject(QJsonObject json) override;
    void fromJson(QString jsonString) override;

    QString getIngredient() const;
    void setIngredient(const QString &ingredient);
    bool is_ingredient_Set() const;
    bool is_ingredient_Valid() const;

    QList<QString> getSubstitutes() const;
    void setSubstitutes(const QList<QString> &substitutes);
    bool is_substitutes_Set() const;
    bool is_substitutes_Valid() const;

    QString getMessage() const;
    void setMessage(const QString &message);
    bool is_message_Set() const;
    bool is_message_Valid() const;

    virtual bool isSet() const override;
    virtual bool isValid() const override;

private:
    void initializeModel();

    QString ingredient;
    bool m_ingredient_isSet;
    bool m_ingredient_isValid;

    QList<QString> substitutes;
    bool m_substitutes_isSet;
    bool m_substitutes_isValid;

    QString message;
    bool m_message_isSet;
    bool m_message_isValid;
};

} // namespace OpenAPI

Q_DECLARE_METATYPE(OpenAPI::OAIGetIngredientSubstitutes_200_response)

#endif // OAIGetIngredientSubstitutes_200_response_H
