/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/*
 * OAIGetMealPlanTemplate_200_response_days_inner_items_inner_value.h
 *
 * 
 */

#ifndef OAIGetMealPlanTemplate_200_response_days_inner_items_inner_value_H
#define OAIGetMealPlanTemplate_200_response_days_inner_items_inner_value_H

#include <QJsonObject>

#include <QString>

#include "OAIEnum.h"
#include "OAIObject.h"

namespace OpenAPI {

class OAIGetMealPlanTemplate_200_response_days_inner_items_inner_value : public OAIObject {
public:
    OAIGetMealPlanTemplate_200_response_days_inner_items_inner_value();
    OAIGetMealPlanTemplate_200_response_days_inner_items_inner_value(QString json);
    ~OAIGetMealPlanTemplate_200_response_days_inner_items_inner_value() override;

    QString asJson() const override;
    QJsonObject asJsonObject() const override;
    void fromJsonObject(QJsonObject json) override;
    void fromJson(QString jsonString) override;

    double getId() const;
    void setId(const double &id);
    bool is_id_Set() const;
    bool is_id_Valid() const;

    QString getTitle() const;
    void setTitle(const QString &title);
    bool is_title_Set() const;
    bool is_title_Valid() const;

    QString getImageType() const;
    void setImageType(const QString &image_type);
    bool is_image_type_Set() const;
    bool is_image_type_Valid() const;

    virtual bool isSet() const override;
    virtual bool isValid() const override;

private:
    void initializeModel();

    double id;
    bool m_id_isSet;
    bool m_id_isValid;

    QString title;
    bool m_title_isSet;
    bool m_title_isValid;

    QString image_type;
    bool m_image_type_isSet;
    bool m_image_type_isValid;
};

} // namespace OpenAPI

Q_DECLARE_METATYPE(OpenAPI::OAIGetMealPlanTemplate_200_response_days_inner_items_inner_value)

#endif // OAIGetMealPlanTemplate_200_response_days_inner_items_inner_value_H
