/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/*
 * OAIGetMealPlanWeek_200_response_days_inner.h
 *
 * 
 */

#ifndef OAIGetMealPlanWeek_200_response_days_inner_H
#define OAIGetMealPlanWeek_200_response_days_inner_H

#include <QJsonObject>

#include "com.spoonacular.client.model\OAIGetMealPlanWeek_200_response_days_inner_items_inner.h"
#include "com.spoonacular.client.model\OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary.h"
#include <QList>
#include <QSet>
#include <QString>

#include "OAIEnum.h"
#include "OAIObject.h"

namespace OpenAPI {
class OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary;
class OAIGetMealPlanWeek_200_response_days_inner_items_inner;

class OAIGetMealPlanWeek_200_response_days_inner : public OAIObject {
public:
    OAIGetMealPlanWeek_200_response_days_inner();
    OAIGetMealPlanWeek_200_response_days_inner(QString json);
    ~OAIGetMealPlanWeek_200_response_days_inner() override;

    QString asJson() const override;
    QJsonObject asJsonObject() const override;
    void fromJsonObject(QJsonObject json) override;
    void fromJson(QString jsonString) override;

    OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary getNutritionSummary() const;
    void setNutritionSummary(const OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary &nutrition_summary);
    bool is_nutrition_summary_Set() const;
    bool is_nutrition_summary_Valid() const;

    OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary getNutritionSummaryBreakfast() const;
    void setNutritionSummaryBreakfast(const OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary &nutrition_summary_breakfast);
    bool is_nutrition_summary_breakfast_Set() const;
    bool is_nutrition_summary_breakfast_Valid() const;

    OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary getNutritionSummaryLunch() const;
    void setNutritionSummaryLunch(const OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary &nutrition_summary_lunch);
    bool is_nutrition_summary_lunch_Set() const;
    bool is_nutrition_summary_lunch_Valid() const;

    OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary getNutritionSummaryDinner() const;
    void setNutritionSummaryDinner(const OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary &nutrition_summary_dinner);
    bool is_nutrition_summary_dinner_Set() const;
    bool is_nutrition_summary_dinner_Valid() const;

    double getDate() const;
    void setDate(const double &date);
    bool is_date_Set() const;
    bool is_date_Valid() const;

    QString getDay() const;
    void setDay(const QString &day);
    bool is_day_Set() const;
    bool is_day_Valid() const;

    QSet<OAIGetMealPlanWeek_200_response_days_inner_items_inner> getItems() const;
    void setItems(const QSet<OAIGetMealPlanWeek_200_response_days_inner_items_inner> &items);
    bool is_items_Set() const;
    bool is_items_Valid() const;

    virtual bool isSet() const override;
    virtual bool isValid() const override;

private:
    void initializeModel();

    OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary nutrition_summary;
    bool m_nutrition_summary_isSet;
    bool m_nutrition_summary_isValid;

    OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary nutrition_summary_breakfast;
    bool m_nutrition_summary_breakfast_isSet;
    bool m_nutrition_summary_breakfast_isValid;

    OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary nutrition_summary_lunch;
    bool m_nutrition_summary_lunch_isSet;
    bool m_nutrition_summary_lunch_isValid;

    OAIGetMealPlanWeek_200_response_days_inner_nutritionSummary nutrition_summary_dinner;
    bool m_nutrition_summary_dinner_isSet;
    bool m_nutrition_summary_dinner_isValid;

    double date;
    bool m_date_isSet;
    bool m_date_isValid;

    QString day;
    bool m_day_isSet;
    bool m_day_isValid;

    QSet<OAIGetMealPlanWeek_200_response_days_inner_items_inner> items;
    bool m_items_isSet;
    bool m_items_isValid;
};

} // namespace OpenAPI

Q_DECLARE_METATYPE(OpenAPI::OAIGetMealPlanWeek_200_response_days_inner)

#endif // OAIGetMealPlanWeek_200_response_days_inner_H
