/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/*
 * OAIGetShoppingList_200_response.h
 *
 * 
 */

#ifndef OAIGetShoppingList_200_response_H
#define OAIGetShoppingList_200_response_H

#include <QJsonObject>

#include "com.spoonacular.client.model\OAIGetShoppingList_200_response_aisles_inner.h"
#include <QList>
#include <QSet>

#include "OAIEnum.h"
#include "OAIObject.h"

namespace OpenAPI {
class OAIGetShoppingList_200_response_aisles_inner;

class OAIGetShoppingList_200_response : public OAIObject {
public:
    OAIGetShoppingList_200_response();
    OAIGetShoppingList_200_response(QString json);
    ~OAIGetShoppingList_200_response() override;

    QString asJson() const override;
    QJsonObject asJsonObject() const override;
    void fromJsonObject(QJsonObject json) override;
    void fromJson(QString jsonString) override;

    QSet<OAIGetShoppingList_200_response_aisles_inner> getAisles() const;
    void setAisles(const QSet<OAIGetShoppingList_200_response_aisles_inner> &aisles);
    bool is_aisles_Set() const;
    bool is_aisles_Valid() const;

    double getCost() const;
    void setCost(const double &cost);
    bool is_cost_Set() const;
    bool is_cost_Valid() const;

    double getStartDate() const;
    void setStartDate(const double &start_date);
    bool is_start_date_Set() const;
    bool is_start_date_Valid() const;

    double getEndDate() const;
    void setEndDate(const double &end_date);
    bool is_end_date_Set() const;
    bool is_end_date_Valid() const;

    virtual bool isSet() const override;
    virtual bool isValid() const override;

private:
    void initializeModel();

    QSet<OAIGetShoppingList_200_response_aisles_inner> aisles;
    bool m_aisles_isSet;
    bool m_aisles_isValid;

    double cost;
    bool m_cost_isSet;
    bool m_cost_isValid;

    double start_date;
    bool m_start_date_isSet;
    bool m_start_date_isValid;

    double end_date;
    bool m_end_date_isSet;
    bool m_end_date_isValid;
};

} // namespace OpenAPI

Q_DECLARE_METATYPE(OpenAPI::OAIGetShoppingList_200_response)

#endif // OAIGetShoppingList_200_response_H
