/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIGuessNutritionByDishName_200_response_calories.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIGuessNutritionByDishName_200_response_calories::OAIGuessNutritionByDishName_200_response_calories(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIGuessNutritionByDishName_200_response_calories::OAIGuessNutritionByDishName_200_response_calories() {
    this->initializeModel();
}

OAIGuessNutritionByDishName_200_response_calories::~OAIGuessNutritionByDishName_200_response_calories() {}

void OAIGuessNutritionByDishName_200_response_calories::initializeModel() {

    m_confidence_range95_percent_isSet = false;
    m_confidence_range95_percent_isValid = false;

    m_standard_deviation_isSet = false;
    m_standard_deviation_isValid = false;

    m_unit_isSet = false;
    m_unit_isValid = false;

    m_value_isSet = false;
    m_value_isValid = false;
}

void OAIGuessNutritionByDishName_200_response_calories::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIGuessNutritionByDishName_200_response_calories::fromJsonObject(QJsonObject json) {

    m_confidence_range95_percent_isValid = ::OpenAPI::fromJsonValue(confidence_range95_percent, json[QString("confidenceRange95Percent")]);
    m_confidence_range95_percent_isSet = !json[QString("confidenceRange95Percent")].isNull() && m_confidence_range95_percent_isValid;

    m_standard_deviation_isValid = ::OpenAPI::fromJsonValue(standard_deviation, json[QString("standardDeviation")]);
    m_standard_deviation_isSet = !json[QString("standardDeviation")].isNull() && m_standard_deviation_isValid;

    m_unit_isValid = ::OpenAPI::fromJsonValue(unit, json[QString("unit")]);
    m_unit_isSet = !json[QString("unit")].isNull() && m_unit_isValid;

    m_value_isValid = ::OpenAPI::fromJsonValue(value, json[QString("value")]);
    m_value_isSet = !json[QString("value")].isNull() && m_value_isValid;
}

QString OAIGuessNutritionByDishName_200_response_calories::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIGuessNutritionByDishName_200_response_calories::asJsonObject() const {
    QJsonObject obj;
    if (confidence_range95_percent.isSet()) {
        obj.insert(QString("confidenceRange95Percent"), ::OpenAPI::toJsonValue(confidence_range95_percent));
    }
    if (m_standard_deviation_isSet) {
        obj.insert(QString("standardDeviation"), ::OpenAPI::toJsonValue(standard_deviation));
    }
    if (m_unit_isSet) {
        obj.insert(QString("unit"), ::OpenAPI::toJsonValue(unit));
    }
    if (m_value_isSet) {
        obj.insert(QString("value"), ::OpenAPI::toJsonValue(value));
    }
    return obj;
}

OAIGuessNutritionByDishName_200_response_calories_confidenceRange95Percent OAIGuessNutritionByDishName_200_response_calories::getConfidenceRange95Percent() const {
    return confidence_range95_percent;
}
void OAIGuessNutritionByDishName_200_response_calories::setConfidenceRange95Percent(const OAIGuessNutritionByDishName_200_response_calories_confidenceRange95Percent &confidence_range95_percent) {
    this->confidence_range95_percent = confidence_range95_percent;
    this->m_confidence_range95_percent_isSet = true;
}

bool OAIGuessNutritionByDishName_200_response_calories::is_confidence_range95_percent_Set() const{
    return m_confidence_range95_percent_isSet;
}

bool OAIGuessNutritionByDishName_200_response_calories::is_confidence_range95_percent_Valid() const{
    return m_confidence_range95_percent_isValid;
}

double OAIGuessNutritionByDishName_200_response_calories::getStandardDeviation() const {
    return standard_deviation;
}
void OAIGuessNutritionByDishName_200_response_calories::setStandardDeviation(const double &standard_deviation) {
    this->standard_deviation = standard_deviation;
    this->m_standard_deviation_isSet = true;
}

bool OAIGuessNutritionByDishName_200_response_calories::is_standard_deviation_Set() const{
    return m_standard_deviation_isSet;
}

bool OAIGuessNutritionByDishName_200_response_calories::is_standard_deviation_Valid() const{
    return m_standard_deviation_isValid;
}

QString OAIGuessNutritionByDishName_200_response_calories::getUnit() const {
    return unit;
}
void OAIGuessNutritionByDishName_200_response_calories::setUnit(const QString &unit) {
    this->unit = unit;
    this->m_unit_isSet = true;
}

bool OAIGuessNutritionByDishName_200_response_calories::is_unit_Set() const{
    return m_unit_isSet;
}

bool OAIGuessNutritionByDishName_200_response_calories::is_unit_Valid() const{
    return m_unit_isValid;
}

double OAIGuessNutritionByDishName_200_response_calories::getValue() const {
    return value;
}
void OAIGuessNutritionByDishName_200_response_calories::setValue(const double &value) {
    this->value = value;
    this->m_value_isSet = true;
}

bool OAIGuessNutritionByDishName_200_response_calories::is_value_Set() const{
    return m_value_isSet;
}

bool OAIGuessNutritionByDishName_200_response_calories::is_value_Valid() const{
    return m_value_isValid;
}

bool OAIGuessNutritionByDishName_200_response_calories::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (confidence_range95_percent.isSet()) {
            isObjectUpdated = true;
            break;
        }

        if (m_standard_deviation_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_unit_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_value_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIGuessNutritionByDishName_200_response_calories::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_confidence_range95_percent_isValid && m_standard_deviation_isValid && m_unit_isValid && m_value_isValid && true;
}

} // namespace OpenAPI
