/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIImageClassificationByURL_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIImageClassificationByURL_200_response::OAIImageClassificationByURL_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIImageClassificationByURL_200_response::OAIImageClassificationByURL_200_response() {
    this->initializeModel();
}

OAIImageClassificationByURL_200_response::~OAIImageClassificationByURL_200_response() {}

void OAIImageClassificationByURL_200_response::initializeModel() {

    m_category_isSet = false;
    m_category_isValid = false;

    m_probability_isSet = false;
    m_probability_isValid = false;
}

void OAIImageClassificationByURL_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIImageClassificationByURL_200_response::fromJsonObject(QJsonObject json) {

    m_category_isValid = ::OpenAPI::fromJsonValue(category, json[QString("category")]);
    m_category_isSet = !json[QString("category")].isNull() && m_category_isValid;

    m_probability_isValid = ::OpenAPI::fromJsonValue(probability, json[QString("probability")]);
    m_probability_isSet = !json[QString("probability")].isNull() && m_probability_isValid;
}

QString OAIImageClassificationByURL_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIImageClassificationByURL_200_response::asJsonObject() const {
    QJsonObject obj;
    if (m_category_isSet) {
        obj.insert(QString("category"), ::OpenAPI::toJsonValue(category));
    }
    if (m_probability_isSet) {
        obj.insert(QString("probability"), ::OpenAPI::toJsonValue(probability));
    }
    return obj;
}

QString OAIImageClassificationByURL_200_response::getCategory() const {
    return category;
}
void OAIImageClassificationByURL_200_response::setCategory(const QString &category) {
    this->category = category;
    this->m_category_isSet = true;
}

bool OAIImageClassificationByURL_200_response::is_category_Set() const{
    return m_category_isSet;
}

bool OAIImageClassificationByURL_200_response::is_category_Valid() const{
    return m_category_isValid;
}

double OAIImageClassificationByURL_200_response::getProbability() const {
    return probability;
}
void OAIImageClassificationByURL_200_response::setProbability(const double &probability) {
    this->probability = probability;
    this->m_probability_isSet = true;
}

bool OAIImageClassificationByURL_200_response::is_probability_Set() const{
    return m_probability_isSet;
}

bool OAIImageClassificationByURL_200_response::is_probability_Valid() const{
    return m_probability_isValid;
}

bool OAIImageClassificationByURL_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_category_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_probability_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIImageClassificationByURL_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_category_isValid && m_probability_isValid && true;
}

} // namespace OpenAPI
