/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAISearchAllFood_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAISearchAllFood_200_response::OAISearchAllFood_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAISearchAllFood_200_response::OAISearchAllFood_200_response() {
    this->initializeModel();
}

OAISearchAllFood_200_response::~OAISearchAllFood_200_response() {}

void OAISearchAllFood_200_response::initializeModel() {

    m_query_isSet = false;
    m_query_isValid = false;

    m_total_results_isSet = false;
    m_total_results_isValid = false;

    m_limit_isSet = false;
    m_limit_isValid = false;

    m_offset_isSet = false;
    m_offset_isValid = false;

    m_search_results_isSet = false;
    m_search_results_isValid = false;
}

void OAISearchAllFood_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAISearchAllFood_200_response::fromJsonObject(QJsonObject json) {

    m_query_isValid = ::OpenAPI::fromJsonValue(query, json[QString("query")]);
    m_query_isSet = !json[QString("query")].isNull() && m_query_isValid;

    m_total_results_isValid = ::OpenAPI::fromJsonValue(total_results, json[QString("totalResults")]);
    m_total_results_isSet = !json[QString("totalResults")].isNull() && m_total_results_isValid;

    m_limit_isValid = ::OpenAPI::fromJsonValue(limit, json[QString("limit")]);
    m_limit_isSet = !json[QString("limit")].isNull() && m_limit_isValid;

    m_offset_isValid = ::OpenAPI::fromJsonValue(offset, json[QString("offset")]);
    m_offset_isSet = !json[QString("offset")].isNull() && m_offset_isValid;

    m_search_results_isValid = ::OpenAPI::fromJsonValue(search_results, json[QString("searchResults")]);
    m_search_results_isSet = !json[QString("searchResults")].isNull() && m_search_results_isValid;
}

QString OAISearchAllFood_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAISearchAllFood_200_response::asJsonObject() const {
    QJsonObject obj;
    if (m_query_isSet) {
        obj.insert(QString("query"), ::OpenAPI::toJsonValue(query));
    }
    if (m_total_results_isSet) {
        obj.insert(QString("totalResults"), ::OpenAPI::toJsonValue(total_results));
    }
    if (m_limit_isSet) {
        obj.insert(QString("limit"), ::OpenAPI::toJsonValue(limit));
    }
    if (m_offset_isSet) {
        obj.insert(QString("offset"), ::OpenAPI::toJsonValue(offset));
    }
    if (search_results.size() > 0) {
        obj.insert(QString("searchResults"), ::OpenAPI::toJsonValue(search_results));
    }
    return obj;
}

QString OAISearchAllFood_200_response::getQuery() const {
    return query;
}
void OAISearchAllFood_200_response::setQuery(const QString &query) {
    this->query = query;
    this->m_query_isSet = true;
}

bool OAISearchAllFood_200_response::is_query_Set() const{
    return m_query_isSet;
}

bool OAISearchAllFood_200_response::is_query_Valid() const{
    return m_query_isValid;
}

qint32 OAISearchAllFood_200_response::getTotalResults() const {
    return total_results;
}
void OAISearchAllFood_200_response::setTotalResults(const qint32 &total_results) {
    this->total_results = total_results;
    this->m_total_results_isSet = true;
}

bool OAISearchAllFood_200_response::is_total_results_Set() const{
    return m_total_results_isSet;
}

bool OAISearchAllFood_200_response::is_total_results_Valid() const{
    return m_total_results_isValid;
}

qint32 OAISearchAllFood_200_response::getLimit() const {
    return limit;
}
void OAISearchAllFood_200_response::setLimit(const qint32 &limit) {
    this->limit = limit;
    this->m_limit_isSet = true;
}

bool OAISearchAllFood_200_response::is_limit_Set() const{
    return m_limit_isSet;
}

bool OAISearchAllFood_200_response::is_limit_Valid() const{
    return m_limit_isValid;
}

qint32 OAISearchAllFood_200_response::getOffset() const {
    return offset;
}
void OAISearchAllFood_200_response::setOffset(const qint32 &offset) {
    this->offset = offset;
    this->m_offset_isSet = true;
}

bool OAISearchAllFood_200_response::is_offset_Set() const{
    return m_offset_isSet;
}

bool OAISearchAllFood_200_response::is_offset_Valid() const{
    return m_offset_isValid;
}

QSet<OAISearchAllFood_200_response_searchResults_inner> OAISearchAllFood_200_response::getSearchResults() const {
    return search_results;
}
void OAISearchAllFood_200_response::setSearchResults(const QSet<OAISearchAllFood_200_response_searchResults_inner> &search_results) {
    this->search_results = search_results;
    this->m_search_results_isSet = true;
}

bool OAISearchAllFood_200_response::is_search_results_Set() const{
    return m_search_results_isSet;
}

bool OAISearchAllFood_200_response::is_search_results_Valid() const{
    return m_search_results_isValid;
}

bool OAISearchAllFood_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_query_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_total_results_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_limit_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_offset_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (search_results.size() > 0) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAISearchAllFood_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_query_isValid && m_total_results_isValid && m_limit_isValid && m_offset_isValid && m_search_results_isValid && true;
}

} // namespace OpenAPI
