/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAISearchAllFood_200_response_searchResults_inner.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAISearchAllFood_200_response_searchResults_inner::OAISearchAllFood_200_response_searchResults_inner(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAISearchAllFood_200_response_searchResults_inner::OAISearchAllFood_200_response_searchResults_inner() {
    this->initializeModel();
}

OAISearchAllFood_200_response_searchResults_inner::~OAISearchAllFood_200_response_searchResults_inner() {}

void OAISearchAllFood_200_response_searchResults_inner::initializeModel() {

    m_name_isSet = false;
    m_name_isValid = false;

    m_total_results_isSet = false;
    m_total_results_isValid = false;

    m_results_isSet = false;
    m_results_isValid = false;
}

void OAISearchAllFood_200_response_searchResults_inner::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAISearchAllFood_200_response_searchResults_inner::fromJsonObject(QJsonObject json) {

    m_name_isValid = ::OpenAPI::fromJsonValue(name, json[QString("name")]);
    m_name_isSet = !json[QString("name")].isNull() && m_name_isValid;

    m_total_results_isValid = ::OpenAPI::fromJsonValue(total_results, json[QString("totalResults")]);
    m_total_results_isSet = !json[QString("totalResults")].isNull() && m_total_results_isValid;

    m_results_isValid = ::OpenAPI::fromJsonValue(results, json[QString("results")]);
    m_results_isSet = !json[QString("results")].isNull() && m_results_isValid;
}

QString OAISearchAllFood_200_response_searchResults_inner::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAISearchAllFood_200_response_searchResults_inner::asJsonObject() const {
    QJsonObject obj;
    if (m_name_isSet) {
        obj.insert(QString("name"), ::OpenAPI::toJsonValue(name));
    }
    if (m_total_results_isSet) {
        obj.insert(QString("totalResults"), ::OpenAPI::toJsonValue(total_results));
    }
    if (results.size() > 0) {
        obj.insert(QString("results"), ::OpenAPI::toJsonValue(results));
    }
    return obj;
}

QString OAISearchAllFood_200_response_searchResults_inner::getName() const {
    return name;
}
void OAISearchAllFood_200_response_searchResults_inner::setName(const QString &name) {
    this->name = name;
    this->m_name_isSet = true;
}

bool OAISearchAllFood_200_response_searchResults_inner::is_name_Set() const{
    return m_name_isSet;
}

bool OAISearchAllFood_200_response_searchResults_inner::is_name_Valid() const{
    return m_name_isValid;
}

qint32 OAISearchAllFood_200_response_searchResults_inner::getTotalResults() const {
    return total_results;
}
void OAISearchAllFood_200_response_searchResults_inner::setTotalResults(const qint32 &total_results) {
    this->total_results = total_results;
    this->m_total_results_isSet = true;
}

bool OAISearchAllFood_200_response_searchResults_inner::is_total_results_Set() const{
    return m_total_results_isSet;
}

bool OAISearchAllFood_200_response_searchResults_inner::is_total_results_Valid() const{
    return m_total_results_isValid;
}

QSet<OAISearchAllFood_200_response_searchResults_inner_results_inner> OAISearchAllFood_200_response_searchResults_inner::getResults() const {
    return results;
}
void OAISearchAllFood_200_response_searchResults_inner::setResults(const QSet<OAISearchAllFood_200_response_searchResults_inner_results_inner> &results) {
    this->results = results;
    this->m_results_isSet = true;
}

bool OAISearchAllFood_200_response_searchResults_inner::is_results_Set() const{
    return m_results_isSet;
}

bool OAISearchAllFood_200_response_searchResults_inner::is_results_Valid() const{
    return m_results_isValid;
}

bool OAISearchAllFood_200_response_searchResults_inner::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_name_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_total_results_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (results.size() > 0) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAISearchAllFood_200_response_searchResults_inner::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_name_isValid && m_total_results_isValid && true;
}

} // namespace OpenAPI
