/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

/*
 * OAISearchAllFood_200_response_searchResults_inner.h
 *
 * 
 */

#ifndef OAISearchAllFood_200_response_searchResults_inner_H
#define OAISearchAllFood_200_response_searchResults_inner_H

#include <QJsonObject>

#include "com.spoonacular.client.model\OAISearchAllFood_200_response_searchResults_inner_results_inner.h"
#include <QList>
#include <QSet>
#include <QString>

#include "OAIEnum.h"
#include "OAIObject.h"

namespace OpenAPI {
class OAISearchAllFood_200_response_searchResults_inner_results_inner;

class OAISearchAllFood_200_response_searchResults_inner : public OAIObject {
public:
    OAISearchAllFood_200_response_searchResults_inner();
    OAISearchAllFood_200_response_searchResults_inner(QString json);
    ~OAISearchAllFood_200_response_searchResults_inner() override;

    QString asJson() const override;
    QJsonObject asJsonObject() const override;
    void fromJsonObject(QJsonObject json) override;
    void fromJson(QString jsonString) override;

    QString getName() const;
    void setName(const QString &name);
    bool is_name_Set() const;
    bool is_name_Valid() const;

    qint32 getTotalResults() const;
    void setTotalResults(const qint32 &total_results);
    bool is_total_results_Set() const;
    bool is_total_results_Valid() const;

    QSet<OAISearchAllFood_200_response_searchResults_inner_results_inner> getResults() const;
    void setResults(const QSet<OAISearchAllFood_200_response_searchResults_inner_results_inner> &results);
    bool is_results_Set() const;
    bool is_results_Valid() const;

    virtual bool isSet() const override;
    virtual bool isValid() const override;

private:
    void initializeModel();

    QString name;
    bool m_name_isSet;
    bool m_name_isValid;

    qint32 total_results;
    bool m_total_results_isSet;
    bool m_total_results_isValid;

    QSet<OAISearchAllFood_200_response_searchResults_inner_results_inner> results;
    bool m_results_isSet;
    bool m_results_isValid;
};

} // namespace OpenAPI

Q_DECLARE_METATYPE(OpenAPI::OAISearchAllFood_200_response_searchResults_inner)

#endif // OAISearchAllFood_200_response_searchResults_inner_H
