/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAISearchMenuItems_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAISearchMenuItems_200_response::OAISearchMenuItems_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAISearchMenuItems_200_response::OAISearchMenuItems_200_response() {
    this->initializeModel();
}

OAISearchMenuItems_200_response::~OAISearchMenuItems_200_response() {}

void OAISearchMenuItems_200_response::initializeModel() {

    m_menu_items_isSet = false;
    m_menu_items_isValid = false;

    m_total_menu_items_isSet = false;
    m_total_menu_items_isValid = false;

    m_type_isSet = false;
    m_type_isValid = false;

    m_offset_isSet = false;
    m_offset_isValid = false;

    m_number_isSet = false;
    m_number_isValid = false;
}

void OAISearchMenuItems_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAISearchMenuItems_200_response::fromJsonObject(QJsonObject json) {

    m_menu_items_isValid = ::OpenAPI::fromJsonValue(menu_items, json[QString("menuItems")]);
    m_menu_items_isSet = !json[QString("menuItems")].isNull() && m_menu_items_isValid;

    m_total_menu_items_isValid = ::OpenAPI::fromJsonValue(total_menu_items, json[QString("totalMenuItems")]);
    m_total_menu_items_isSet = !json[QString("totalMenuItems")].isNull() && m_total_menu_items_isValid;

    m_type_isValid = ::OpenAPI::fromJsonValue(type, json[QString("type")]);
    m_type_isSet = !json[QString("type")].isNull() && m_type_isValid;

    m_offset_isValid = ::OpenAPI::fromJsonValue(offset, json[QString("offset")]);
    m_offset_isSet = !json[QString("offset")].isNull() && m_offset_isValid;

    m_number_isValid = ::OpenAPI::fromJsonValue(number, json[QString("number")]);
    m_number_isSet = !json[QString("number")].isNull() && m_number_isValid;
}

QString OAISearchMenuItems_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAISearchMenuItems_200_response::asJsonObject() const {
    QJsonObject obj;
    if (menu_items.size() > 0) {
        obj.insert(QString("menuItems"), ::OpenAPI::toJsonValue(menu_items));
    }
    if (m_total_menu_items_isSet) {
        obj.insert(QString("totalMenuItems"), ::OpenAPI::toJsonValue(total_menu_items));
    }
    if (m_type_isSet) {
        obj.insert(QString("type"), ::OpenAPI::toJsonValue(type));
    }
    if (m_offset_isSet) {
        obj.insert(QString("offset"), ::OpenAPI::toJsonValue(offset));
    }
    if (m_number_isSet) {
        obj.insert(QString("number"), ::OpenAPI::toJsonValue(number));
    }
    return obj;
}

QSet<OAISearchMenuItems_200_response_menuItems_inner> OAISearchMenuItems_200_response::getMenuItems() const {
    return menu_items;
}
void OAISearchMenuItems_200_response::setMenuItems(const QSet<OAISearchMenuItems_200_response_menuItems_inner> &menu_items) {
    this->menu_items = menu_items;
    this->m_menu_items_isSet = true;
}

bool OAISearchMenuItems_200_response::is_menu_items_Set() const{
    return m_menu_items_isSet;
}

bool OAISearchMenuItems_200_response::is_menu_items_Valid() const{
    return m_menu_items_isValid;
}

qint32 OAISearchMenuItems_200_response::getTotalMenuItems() const {
    return total_menu_items;
}
void OAISearchMenuItems_200_response::setTotalMenuItems(const qint32 &total_menu_items) {
    this->total_menu_items = total_menu_items;
    this->m_total_menu_items_isSet = true;
}

bool OAISearchMenuItems_200_response::is_total_menu_items_Set() const{
    return m_total_menu_items_isSet;
}

bool OAISearchMenuItems_200_response::is_total_menu_items_Valid() const{
    return m_total_menu_items_isValid;
}

QString OAISearchMenuItems_200_response::getType() const {
    return type;
}
void OAISearchMenuItems_200_response::setType(const QString &type) {
    this->type = type;
    this->m_type_isSet = true;
}

bool OAISearchMenuItems_200_response::is_type_Set() const{
    return m_type_isSet;
}

bool OAISearchMenuItems_200_response::is_type_Valid() const{
    return m_type_isValid;
}

qint32 OAISearchMenuItems_200_response::getOffset() const {
    return offset;
}
void OAISearchMenuItems_200_response::setOffset(const qint32 &offset) {
    this->offset = offset;
    this->m_offset_isSet = true;
}

bool OAISearchMenuItems_200_response::is_offset_Set() const{
    return m_offset_isSet;
}

bool OAISearchMenuItems_200_response::is_offset_Valid() const{
    return m_offset_isValid;
}

qint32 OAISearchMenuItems_200_response::getNumber() const {
    return number;
}
void OAISearchMenuItems_200_response::setNumber(const qint32 &number) {
    this->number = number;
    this->m_number_isSet = true;
}

bool OAISearchMenuItems_200_response::is_number_Set() const{
    return m_number_isSet;
}

bool OAISearchMenuItems_200_response::is_number_Valid() const{
    return m_number_isValid;
}

bool OAISearchMenuItems_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (menu_items.size() > 0) {
            isObjectUpdated = true;
            break;
        }

        if (m_total_menu_items_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_type_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_offset_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_number_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAISearchMenuItems_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_menu_items_isValid && m_total_menu_items_isValid && m_type_isValid && m_offset_isValid && m_number_isValid && true;
}

} // namespace OpenAPI
