/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAISearchRestaurants_200_response.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAISearchRestaurants_200_response::OAISearchRestaurants_200_response(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAISearchRestaurants_200_response::OAISearchRestaurants_200_response() {
    this->initializeModel();
}

OAISearchRestaurants_200_response::~OAISearchRestaurants_200_response() {}

void OAISearchRestaurants_200_response::initializeModel() {

    m_restaurants_isSet = false;
    m_restaurants_isValid = false;
}

void OAISearchRestaurants_200_response::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAISearchRestaurants_200_response::fromJsonObject(QJsonObject json) {

    m_restaurants_isValid = ::OpenAPI::fromJsonValue(restaurants, json[QString("restaurants")]);
    m_restaurants_isSet = !json[QString("restaurants")].isNull() && m_restaurants_isValid;
}

QString OAISearchRestaurants_200_response::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAISearchRestaurants_200_response::asJsonObject() const {
    QJsonObject obj;
    if (restaurants.size() > 0) {
        obj.insert(QString("restaurants"), ::OpenAPI::toJsonValue(restaurants));
    }
    return obj;
}

QList<OAISearchRestaurants_200_response_restaurants_inner> OAISearchRestaurants_200_response::getRestaurants() const {
    return restaurants;
}
void OAISearchRestaurants_200_response::setRestaurants(const QList<OAISearchRestaurants_200_response_restaurants_inner> &restaurants) {
    this->restaurants = restaurants;
    this->m_restaurants_isSet = true;
}

bool OAISearchRestaurants_200_response::is_restaurants_Set() const{
    return m_restaurants_isSet;
}

bool OAISearchRestaurants_200_response::is_restaurants_Valid() const{
    return m_restaurants_isValid;
}

bool OAISearchRestaurants_200_response::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (restaurants.size() > 0) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAISearchRestaurants_200_response::isValid() const {
    // only required properties are required for the object to be considered valid
    return true;
}

} // namespace OpenAPI
