/**
 * spoonacular API
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

#include "OAIGetComparableProducts_200_response_comparableProducts_protein_inner.h"

#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>
#include <QObject>

#include "OAIHelpers.h"

namespace OpenAPI {

OAIGetComparableProducts_200_response_comparableProducts_protein_inner::OAIGetComparableProducts_200_response_comparableProducts_protein_inner(QString json) {
    this->initializeModel();
    this->fromJson(json);
}

OAIGetComparableProducts_200_response_comparableProducts_protein_inner::OAIGetComparableProducts_200_response_comparableProducts_protein_inner() {
    this->initializeModel();
}

OAIGetComparableProducts_200_response_comparableProducts_protein_inner::~OAIGetComparableProducts_200_response_comparableProducts_protein_inner() {}

void OAIGetComparableProducts_200_response_comparableProducts_protein_inner::initializeModel() {

    m_difference_isSet = false;
    m_difference_isValid = false;

    m_id_isSet = false;
    m_id_isValid = false;

    m_image_isSet = false;
    m_image_isValid = false;

    m_title_isSet = false;
    m_title_isValid = false;
}

void OAIGetComparableProducts_200_response_comparableProducts_protein_inner::fromJson(QString jsonString) {
    QByteArray array(jsonString.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
}

void OAIGetComparableProducts_200_response_comparableProducts_protein_inner::fromJsonObject(QJsonObject json) {

    m_difference_isValid = ::OpenAPI::fromJsonValue(difference, json[QString("difference")]);
    m_difference_isSet = !json[QString("difference")].isNull() && m_difference_isValid;

    m_id_isValid = ::OpenAPI::fromJsonValue(id, json[QString("id")]);
    m_id_isSet = !json[QString("id")].isNull() && m_id_isValid;

    m_image_isValid = ::OpenAPI::fromJsonValue(image, json[QString("image")]);
    m_image_isSet = !json[QString("image")].isNull() && m_image_isValid;

    m_title_isValid = ::OpenAPI::fromJsonValue(title, json[QString("title")]);
    m_title_isSet = !json[QString("title")].isNull() && m_title_isValid;
}

QString OAIGetComparableProducts_200_response_comparableProducts_protein_inner::asJson() const {
    QJsonObject obj = this->asJsonObject();
    QJsonDocument doc(obj);
    QByteArray bytes = doc.toJson();
    return QString(bytes);
}

QJsonObject OAIGetComparableProducts_200_response_comparableProducts_protein_inner::asJsonObject() const {
    QJsonObject obj;
    if (m_difference_isSet) {
        obj.insert(QString("difference"), ::OpenAPI::toJsonValue(difference));
    }
    if (m_id_isSet) {
        obj.insert(QString("id"), ::OpenAPI::toJsonValue(id));
    }
    if (m_image_isSet) {
        obj.insert(QString("image"), ::OpenAPI::toJsonValue(image));
    }
    if (m_title_isSet) {
        obj.insert(QString("title"), ::OpenAPI::toJsonValue(title));
    }
    return obj;
}

double OAIGetComparableProducts_200_response_comparableProducts_protein_inner::getDifference() const {
    return difference;
}
void OAIGetComparableProducts_200_response_comparableProducts_protein_inner::setDifference(const double &difference) {
    this->difference = difference;
    this->m_difference_isSet = true;
}

bool OAIGetComparableProducts_200_response_comparableProducts_protein_inner::is_difference_Set() const{
    return m_difference_isSet;
}

bool OAIGetComparableProducts_200_response_comparableProducts_protein_inner::is_difference_Valid() const{
    return m_difference_isValid;
}

qint32 OAIGetComparableProducts_200_response_comparableProducts_protein_inner::getId() const {
    return id;
}
void OAIGetComparableProducts_200_response_comparableProducts_protein_inner::setId(const qint32 &id) {
    this->id = id;
    this->m_id_isSet = true;
}

bool OAIGetComparableProducts_200_response_comparableProducts_protein_inner::is_id_Set() const{
    return m_id_isSet;
}

bool OAIGetComparableProducts_200_response_comparableProducts_protein_inner::is_id_Valid() const{
    return m_id_isValid;
}

QString OAIGetComparableProducts_200_response_comparableProducts_protein_inner::getImage() const {
    return image;
}
void OAIGetComparableProducts_200_response_comparableProducts_protein_inner::setImage(const QString &image) {
    this->image = image;
    this->m_image_isSet = true;
}

bool OAIGetComparableProducts_200_response_comparableProducts_protein_inner::is_image_Set() const{
    return m_image_isSet;
}

bool OAIGetComparableProducts_200_response_comparableProducts_protein_inner::is_image_Valid() const{
    return m_image_isValid;
}

QString OAIGetComparableProducts_200_response_comparableProducts_protein_inner::getTitle() const {
    return title;
}
void OAIGetComparableProducts_200_response_comparableProducts_protein_inner::setTitle(const QString &title) {
    this->title = title;
    this->m_title_isSet = true;
}

bool OAIGetComparableProducts_200_response_comparableProducts_protein_inner::is_title_Set() const{
    return m_title_isSet;
}

bool OAIGetComparableProducts_200_response_comparableProducts_protein_inner::is_title_Valid() const{
    return m_title_isValid;
}

bool OAIGetComparableProducts_200_response_comparableProducts_protein_inner::isSet() const {
    bool isObjectUpdated = false;
    do {
        if (m_difference_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_id_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_image_isSet) {
            isObjectUpdated = true;
            break;
        }

        if (m_title_isSet) {
            isObjectUpdated = true;
            break;
        }
    } while (false);
    return isObjectUpdated;
}

bool OAIGetComparableProducts_200_response_comparableProducts_protein_inner::isValid() const {
    // only required properties are required for the object to be considered valid
    return m_difference_isValid && m_id_isValid && m_image_isValid && m_title_isValid && true;
}

} // namespace OpenAPI
